// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 20 diciembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// Se crean cuatro Aisladors de Comida Caliente para comedor.  Se ubica
// segun las siguientes coordenadas:
// AisladorMargarita
// Radio        = 67.25*L
// Altura       = 16.75*L
// AisladorFlor
// Radio        = 71.75*L
// Altura       = 15.25*L
// AisladorBodegon
// Radio        = 71.75*L
// Altura       = 10.75*L
// AisladorHexagonal
// Radio        ~ 70*L
// Altura       ~ 3.5*L 
// 
// Los cuatro se ubican con la parte inferior centrada en el origen
// y los cuatro apuntan hacia z negativo
// Los objetos respectivos se llaman
// ACOC_AisladorMargarita, ACOC_AisladorFlor, ACOC_AisladorBodegon,
// y ACOC_AisladorHexagonal
// Para su utilizacion simplemente...
// include "ACOC.inc"
// object { ACOC_AisladorFlor }
//
// Similar para los otros. Pueden generarse mediante la macro
// ACOC_AisladorComedorObjetoCaliente( Estilo, Param1, Param2, Param3 )
// Estilo       : los cuatro estilos se identifican con los valores
//              (se indican valores Default)
//      ACOC_Margarita
//              Param1  : radio de circulo mayor, 66*L
//              Param2  : radio de circulo menor, 14.5*L
//              Param3  : cambiar el grueso como fraccion, 1.0 
//      ACOC_Flor
//              Param1  : diametro de circulo mayor, 141*L
//              Param2  : diametro de ciruclo menor, 107*L
//              Param3  : cambiar el grueso como fraccion, 1.0   
//      ACOC_Bodegon
//              Param1  : si 0 utilizar dibujo y textura default
//                        otras opciones es para el tipo de dibujo, 0
//                      ACOC_jpeg       para imagen tipo jpeg
//                      ACOC_png        para imagen tipo png
//                      ACOC_sys        para imagen tipo sys
//              Param2  : archivo de imagen como string
//              Param3  : color de la base inferior
//              Nota: caso default (ACOC_Bodegon,0,"",0)
//                      se exige Param1 = 0 para default
//      ACOC_Hexagonal  
//              Param1  : Largo del elemento basico, 13*L
//              Param2  : Ancho cuadrangular del elemento basico, 3.5*L
//              Param3  : Los elementos del borde, pueden
//                        ser un poco mas grandes de largo, 1.1
// Ejemplo 
// object       {
//   ACOC_AisladorComedorObjetoCaliente
//              ( ACOC_Bodegon, ACOC_png, "mtmandj.png", Cyan )
//                      // mtmandj.png viene con PovRay
// }
// Otros modificadores validos serian:
//    (si se indica es default)
// #declare ACOC_POV3_1 = off;
//      al activarse "on", provoca simplificaciones
//      para que sea compatible con POVRay 3.1.
//      En algunas versiones de POVRay se activa automticamente.
// #declare ACOC_S      = 2234;
//      para semilla aleatoria, util en ACOC_Hexagonal
// #declare ACOC_TexturaMetalicaAislador_0        = texture { ... }
//      Para el Aislador metalico de ACOC_Margarita
// #declare ACOC_TexturaMetalicaAislador_1        = texture { ... }
//      Para el Aislador metalico de ACOC_Flor
// #declare ACOC_TexturaPatitaPlastico_0         = texture { ... }
//      Para la patita plastica de ACOC_Margarita
// #declare ACOC_TexturaPatitaPlastico_1         = texture { ... }
//      Para la patita plastica de ACOC_Flor
// #declare ACOC_TexturaImagenSuperficie_2       = texture { ... }   
//      para redefinir la imagen o lo que se quiera utilizar
//      en la zona plana de ACOC_Bodegon
// #declare ACOC_BodegonImagen  = "ACOC_Bodegon.gif"
//      string para la imagen default, debera ser jpg,
//      util si no se redefine ACOC_TexturaImagenSuperficie_2
//      en el modo ACOC_POV3_1 debera utilizar un tipo gif.
// #declare ACOC_TexturaAisladorPlastico_2        = texture { ... }
//      Textura default de la base del bodegon 
// #declare ACOC_DistanciaBasico_3       =  13*L;
//      Permite cambiar el largo default del elemento basico 
//      de ACOC_Hexagonal
// #declare ACOC_AnchoBasico_3           =  3.5*L;
//      Permite cambiar el ancho cuadrangular default
//      del elemento basico de ACOC_Hexagonal
// #declare ACOC_TexturaHilo_3                   = texture { ... }       
//      Util si no se redifine ACOC_FiguraBasico_3
//      permite cambiar la textura del hilo blanco en ACOC_Hexagonal
// #macro ACOC_FiguraBasico_3 ( Distancia, Ancho )  
//      Redefinible, para ACOC_Hexagonal se supone crea una figura
//      sustituta para el elememento basico hexagonal
//      Distancia es el largobasico de la figura, y Ancho se
//      toma como base cuadrada
// #declare ACOC_TexturaMaderaAislador_3  = texture { ... }
//      Para la textura de madera basica de ACOC_Hexagonal
// #declare ACOC_TexturaMaderaVerde_3    = texture { ... }
//      Para la textura de madera verde en el default, redefina a gusto
// #declare ACOC_TexturaMaderaRojo_3    = texture { ... }
//      Para la textura de madera rojo  en el default, redefina a gusto
// #declare ACOC_TexturaMaderaAzul_3    = texture { ... }
//      Para la textura de madera azul  en el default, redefina a gusto
// #declare ACOC_TexturaMaderaBorde_3   = texture { ... }
//      Permite redefinir la textura del borde de ACOC_Hexagonal
//      por default se define identica a ACOC_TexturaMaderaAislador_3
// 

#include "colors.inc"
#include "metals.inc"  
#include "woods.inc"
 
#ifndef ( ACOC_POV3_1 ) 
  #if ( version < 3.2 )
    #declare ACOC_POV3_1        = on;
  #else
    #declare ACOC_POV3_1        = off;
  #end
#end 
 
#ifndef ( ACOC_Seed ) 
  #declare ACOC_Seed    = 2234;
#end

#declare ACOC_S         = seed( ACOC_Seed ); 
#declare ACOC_Margarita = 0;
#declare ACOC_Flor      = 1;
#declare ACOC_Bodegon   = 2;
#declare ACOC_Hexagonal = 3;
#declare ACOC_jpeg      = 1;
#declare ACOC_png       = 2;
#declare ACOC_sys       = 3;  
#local   L              = 0.001;
 
#ifndef( ACOC_TexturaMetalicaAislador_0 )
  #declare ACOC_TexturaMetalicaAislador_0        = texture       {
     T_Chrome_4D
     normal     { wrinkles scale 0.5        }
  }
#end  

#ifndef( ACOC_TexturaMetalicaAislador_1 )
  #declare ACOC_TexturaMetalicaAislador_1        = texture       {
     T_Chrome_4D
     normal     { wrinkles scale 0.5        }
  }
#end

#ifndef( ACOC_TexturaPatitaPlastico_0 )
  #declare ACOC_TexturaPatitaPlastico_0         = texture       {
     pigment    { color Gray20 }
     normal     { bumps  scale 0.01         }
  }
#end

#ifndef( ACOC_TexturaPatitaPlastico_1 )
  #declare ACOC_TexturaPatitaPlastico_1         = texture       {
     pigment    { color Gray20 }
     normal     { bumps  scale 0.01         }
  }
#end
    
#ifndef( ACOC_TexturaImagenSuperficie_2 )
  #declare ACOC_TexturaImagenSuperficie_2       = texture       {
     pigment    { 
       image_map        { 
         #ifndef ( ACOC_BodegonImagen )
           gif  "ACOC_Bod.gif"
         #else
           #if ( ACOC_POV3_1 )
             gif  ACOC_BodegonImagen
           #else
             jpeg ACOC_BodegonImagen
           #end
         #end
       }
     }                 
     normal     { bumps scale 0.3 }
  }
#end    
   
#ifndef( ACOC_TexturaAisladorPlastico_2 )
  #declare ACOC_TexturaAisladorPlastico_2        = texture       {
     pigment    { color White }    
     normal     { bumps scale 0.3 }
  }
#end

#ifndef ( ACOC_DistanciaBasico_3 ) 
  #declare ACOC_DistanciaBasico_3       =  13*L;
#end

#ifndef ( ACOC_AnchoBasico_3 ) 
  #declare ACOC_AnchoBasico_3           =  3.5*L;
#end

#ifndef ( ACOC_TexturaHilo_3 )
  #declare ACOC_TexturaHilo_3           = texture       {
    pigment     { White }
    normal      { granite scale 0.001 }
  }
#end       

#ifndef ( ACOC_FiguraBasico_3 )            
  #macro ACOC_FiguraBasico_3 ( Distancia, Ancho )  
    union         { 
      #local FraccionHueco                = 0.1;  
      #local FraccionHilo                 = 0.1;
      #local ExcesoHilo                   = 1.3;
      #local PuntoFundamental             = < Distancia, Ancho >/2;
      difference          {
        prism           {   
          cubic_spline
          -Ancho/2, Ancho/2, 9,
          PuntoFundamental*<1,-1>,
          PuntoFundamental,
          PuntoFundamental*<0,1.5>, 
          PuntoFundamental*<-1,1>, 
          PuntoFundamental*<-1,-1>, 
          PuntoFundamental*<0,-1.5>, 
          PuntoFundamental*<1,-1>,
          PuntoFundamental, 
          PuntoFundamental*<0,1.5>
          rotate          -90*x
        }
        cylinder          {
          -Distancia*x,
          Distancia*x,
          FraccionHueco*Ancho
        }      
      }
      cylinder          {
        -ExcesoHilo*Distancia/2*x,
        ExcesoHilo*Distancia/2*x,
        FraccionHilo*Ancho
        texture           { 
          ACOC_TexturaHilo_3
        }
      }
      rotate   2*< rand(ACOC_S)-0.5, rand(ACOC_S)-0.5, rand(ACOC_S)-0.5> 
    } 
  #end
#end 

#ifndef( ACOC_TexturaMaderaAislador_3 )
  #declare ACOC_TexturaMaderaAislador_3          = texture       {
     T_Wood7
     scale      0.01    
     translate  <1,1,1>
     rotate     25
  }
#end
 
#local TexturaVerde     = texture       {
  pigment       { rgbt < 0.1, 0.7, 0.1, 0.5 > }
} 

#ifndef( ACOC_TexturaMaderaVerde_3 )
  #declare ACOC_TexturaMaderaVerde_3            = texture       {  
     average
     texture_map        {
       [ ACOC_TexturaMaderaAislador_3 ]
       [ TexturaVerde                ]
     }
  }
#end

#local TexturaRojo      = texture       {
  pigment       { rgbt < 1.0, 0.1, 0.0, 0.2 > }
} 

#ifndef( ACOC_TexturaMaderaRojo_3 )
  #declare ACOC_TexturaMaderaRojo_3             = texture       {  
     average
     texture_map        {
       [ ACOC_TexturaMaderaAislador_3 ]
       [ TexturaRojo                 ]
     }
  }
#end

#local TexturaAzul      = texture       {
  pigment       { rgbt < 0.0, 0.1, 1.0, 0.2 > }
} 

#ifndef( ACOC_TexturaMaderaAzul_3 )
  #declare ACOC_TexturaMaderaAzul_3             = texture       {  
     average
     texture_map        {
       [ ACOC_TexturaMaderaAislador_3 ]
       [ TexturaAzul                 ]
     }
  }
#end  

#ifndef ( ACOC_TexturaMaderaBorde_3 )
  #declare ACOC_TexturaMaderaBorde_3            = texture       {
    ACOC_TexturaMaderaAislador_3
  }
#end

#macro ACOC_AisladorComedorObjetoCaliente( Estilo, Param1, Param2, Param3 )
  #local L                      = 0.001;
  #switch( Estilo )
    #case ( ACOC_Margarita )
    
      #local RadioMayor         = Param1;
      #local RadioMenor         = Param2;
      #local NumeroPetalos      = 5;
      #local NumeroPatitas      = 3; 
      #local AnguloFasePatitas  = 360/( 2*NumeroPetalos );
      #local DiametroGrueso     = Param3*3.5*L;
      #local DiametroMediano    = Param3*3.5*L;
      #local DiametroPatitaEsfera               = Param3*11.5*L;
      #local AlturaAislador      = 15*L;
      #local FactorAnguloBasePetalo             = 0.6;
      #local RadioCentralPetalo = ( RadioMayor+RadioMenor )/2;
      #local FactorAnguloCentroPetalo           = 0.5;
      #local AnguloBasePetalo   = 
                FactorAnguloBasePetalo*360/( 2*NumeroPetalos );
      #local AnguloCentralPetalo                = 
                FactorAnguloCentroPetalo*360/( 2*NumeroPetalos );
      #local BasePetalo         = 
             < RadioMenor*cos( radians( AnguloBasePetalo ) ),
               RadioMenor*sin( radians( AnguloBasePetalo ) ), 0 >;
      #local CentroPetalo       =
           < RadioCentralPetalo*cos( radians( AnguloCentralPetalo ) ),
             RadioCentralPetalo*sin( radians( AnguloCentralPetalo ) ), 0 >;         
      #if ( ACOC_POV3_1 = off )       
      #local SplinePetalo       = spline        { 
        cubic_spline 
        -0.5    , 0
        0       , BasePetalo
        0.5     , CentroPetalo
        1       , < RadioMayor-( DiametroGrueso+DiametroMediano )/2, 0, 0 >
        1.5     , < CentroPetalo.x, -CentroPetalo.y, 0 >
        2       , < BasePetalo.x   , -BasePetalo.y   , 0 >
        2.5     , 0
      }     
      
      #local Petalo             = sphere_sweep  {
        cubic_spline, 
        7 
        #local C            = -0.5;
        #local MaximoC      = 2.6;     
        #while ( C < MaximoC )   
          SplinePetalo( C ) , DiametroMediano/2        
          #local C          = C+0.5;
        #end
        tolerance 1.0e-6
      }
      #else
        #local Petalo           = union {
          cylinder      {
            BasePetalo  , CentroPetalo, DiametroMediano/2
          }
          cylinder      {
            CentroPetalo, 
            < RadioMayor-( DiametroGrueso+DiametroMediano )/2, 0, 0 >,
            DiametroMediano/2
          } 
          cylinder      {
            < RadioMayor-( DiametroGrueso+DiametroMediano )/2, 0, 0 >,
            < CentroPetalo.x, -CentroPetalo.y, 0 >,
            DiametroMediano/2
          }
          cylinder      {
            < CentroPetalo.x, -CentroPetalo.y, 0 >,
            < BasePetalo.x   , -BasePetalo.y   , 0 >,
            DiametroMediano/2
          }
        }
      #end
      union     {
        union           {
          torus         {
            RadioMayor    , DiametroGrueso/2
            sturm
            rotate        -90*x
          }
          torus         {
            RadioMenor    , DiametroGrueso/2
            sturm
            translate   -( DiametroGrueso+DiametroMediano )/2*y
            rotate        -90*x
          }  
          #local B      = 0;
          #while ( B < NumeroPetalos )
            object      {
              Petalo
              rotate    B*360/NumeroPetalos*z
            }     
            #local B    = B+1;
          #end
          #local B      = 0;
          #while ( B < NumeroPatitas ) 
            cylinder    {
              #local RadianActual       =
                        radians( AnguloFasePatitas+B*360/NumeroPatitas );
              < RadioMayor*cos( RadianActual ),
                RadioMayor*sin( RadianActual ), 0 >,
              < RadioMayor*cos( RadianActual ),
                RadioMayor*sin( RadianActual ), 
                AlturaAislador-DiametroPatitaEsfera/2 >, 
              DiametroMediano/2              
            }
            #local B    = B+1;
          #end
          texture       {
            ACOC_TexturaMetalicaAislador_0
          }
        }
        #local  B       = 0;
        #while ( B < NumeroPatitas )
          #local RadianActual       =
                        radians( AnguloFasePatitas+B*360/NumeroPatitas );
          sphere        {
            < RadioMayor*cos( RadianActual ),
              RadioMayor*sin( RadianActual ),
              AlturaAislador-DiametroPatitaEsfera/2 >,
            DiametroPatitaEsfera/2
            texture     {
              ACOC_TexturaPatitaPlastico_0
            }
          }
          #local B      = B+1;
        #end 
        translate       -AlturaAislador*z
      }
      
    #break
    #case ( ACOC_Flor )
      #local DiametroGrande     = Param1;
      #local DiametroMediano    = Param2;
      #local GruesoPrincipal    = Param3*2.5*L;
      #local GruesoFlor         = Param3*1.8*L;
      #local FraccionAislador    = 1.06;
      #local DiametroEsferitaAislador            = Param3*8.5*L;
      #local AlturaBase         = 14*L; 
      #local FraccionCurvaFinalAislador          = 1.5;
      #local PuntoLateralAislador                =
                ( -FraccionCurvaFinalAislador*GruesoPrincipal
                  +FraccionAislador*DiametroGrande/2 )*x;
      #local FraccionCurvaInicialAislador        = 0.22;
      #local PuntoCentralAislador                =
                FraccionCurvaInicialAislador*DiametroMediano/2*x;

      #local FinalPie           = union         {
        difference      {
          torus           {           
            FraccionCurvaFinalAislador*GruesoPrincipal,
            GruesoPrincipal/2 
            sturm
          }
          plane         {
            x, 0
          }
          plane         {
            -z, 0
          }
          translate   PuntoLateralAislador
                +FraccionCurvaFinalAislador*GruesoPrincipal*z
        } 
        cylinder        {
          FraccionAislador*DiametroGrande/2*x
                +FraccionCurvaFinalAislador*GruesoPrincipal*z,
          FraccionAislador*DiametroGrande/2*x
                +( AlturaBase-DiametroEsferitaAislador/2 )*z,
          GruesoPrincipal/2
        }
        sphere          {
          FraccionAislador*DiametroGrande/2*x
                +( AlturaBase-DiametroEsferitaAislador/2 )*z,
          DiametroEsferitaAislador/2
          texture       {
            ACOC_TexturaPatitaPlastico_1
          }              
        }
      }
      
      union             {
        union           {  
          torus         {
            DiametroGrande/2    , GruesoPrincipal/2
            rotate      -90*x
          } 
          torus         {
            DiametroMediano/2   , GruesoPrincipal/2
            rotate      -90*x
          } 
          #local Rosa0        = <0,0.8,0>*DiametroMediano/2;
          #local Rosa1        = <0.08,0.60,0>*DiametroMediano/2;
          #local Rosa2        = <0.25,0.8,0>*DiametroMediano/2;
          #local Rosa3        = <0.50,0.36,0>*DiametroMediano/2;
          #local Rosa4        = <0,0.09,0>*DiametroMediano/2;
          #local InversorX    = <-1,1,1>;
          #if ( ACOC_POV3_1 = off )
          sphere_sweep        {
            b_spline,
            11,
            Rosa1*InversorX   , GruesoFlor/2,
            Rosa0             , GruesoFlor/2,
            Rosa1             , GruesoFlor/2,
            Rosa2             , GruesoFlor/2,
            Rosa3             , GruesoFlor/2,
            Rosa4             , GruesoFlor/2,
            Rosa3*InversorX   , GruesoFlor/2,
            Rosa2*InversorX   , GruesoFlor/2,
            Rosa1*InversorX   , GruesoFlor/2, 
            Rosa0             , GruesoFlor/2,
            Rosa1             , GruesoFlor/2
            translate           ( GruesoPrincipal-GruesoFlor )/2
          }
          #else
            union       {
              cylinder          {
                Rosa0         , Rosa1           , GruesoFlor/2
              }
              cylinder          {
                Rosa1         , Rosa2           , GruesoFlor/2
              }
              cylinder          {
                Rosa2         , Rosa3           , GruesoFlor/2
              }
              cylinder          {
                Rosa3         , Rosa4           , GruesoFlor/2
              }
              cylinder          {
                Rosa4         , Rosa3*InversorX , GruesoFlor/2
              }
              cylinder          {
                Rosa3*InversorX, Rosa2*InversorX , GruesoFlor/2
              }
              cylinder          {
                Rosa2*InversorX, Rosa1*InversorX  , GruesoFlor/2
              }
              cylinder          {
                Rosa1*InversorX, Rosa0           , GruesoFlor/2
              }
              translate           ( GruesoPrincipal-GruesoFlor )/2
            }
          #end 
          #local Hoja0        = <0,-0.45,0>*DiametroMediano/2;
          #local Hoja1        = <0.26,-0.26,0>*DiametroMediano/2;
          #local Hoja2        = <0.56,-0.13,0>*DiametroMediano/2;
          #local Hoja3        = <0.46,-0.52,0>*DiametroMediano/2;
          #local Hoja4        = <0,-0.74,0>*DiametroMediano/2;  
          #if ( ACOC_POV3_1 = off )
          sphere_sweep        {
            cubic_spline,
            11,
            Hoja1*InversorX   , GruesoFlor/2,
            Hoja0             , GruesoFlor/2,
            Hoja1             , GruesoFlor/2,
            Hoja2             , GruesoFlor/2,
            Hoja3             , GruesoFlor/2,
            Hoja4             , GruesoFlor/2,
            Hoja3*InversorX   , GruesoFlor/2,
            Hoja2*InversorX   , GruesoFlor/2,
            Hoja1*InversorX   , GruesoFlor/2, 
            Hoja0             , GruesoFlor/2,
            Hoja1             , GruesoFlor/2
            translate           ( GruesoPrincipal-GruesoFlor )/2
          }
          #else
            union       {
              cylinder          {
                Hoja0           , Hoja1         , GruesoFlor/2
              }
              cylinder          {
                Hoja1           , Hoja2         , GruesoFlor/2
              }
              cylinder          {
                Hoja2           , Hoja3         , GruesoFlor/2
              }
              cylinder          {
                Hoja3           , Hoja4         , GruesoFlor/2
              }
              cylinder          {
                Hoja4           , Hoja3*InversorX       , GruesoFlor/2
              }
              cylinder          {
                Hoja3*InversorX , Hoja2*InversorX       , GruesoFlor/2
              }
              cylinder          {
                Hoja2*InversorX , Hoja1*InversorX       , GruesoFlor/2
              }
              cylinder          {
                Hoja1*InversorX , Hoja0                 , GruesoFlor/2
              }
              translate           ( GruesoPrincipal-GruesoFlor )/2            
            }
          #end 
          union         {
            cylinder    {
              PuntoCentralAislador       , PuntoLateralAislador,
              GruesoPrincipal/2
            }
            cylinder    {
              -PuntoCentralAislador      , -PuntoLateralAislador,
              GruesoPrincipal/2
            }  
            cylinder    {
              PuntoLateralAislador       , -PuntoLateralAislador,
              GruesoPrincipal/2
              rotate    90*z
            }
            #if ( ACOC_POV3_1 = off )         
            sphere_sweep        {
              cubic_spline
              5,
              2*PuntoCentralAislador+GruesoPrincipal*z,  GruesoPrincipal/2,
              PuntoCentralAislador,                      GruesoPrincipal/2,
              GruesoPrincipal*z,                        GruesoPrincipal/2,
              -PuntoCentralAislador,                     GruesoPrincipal/2,
              -2*PuntoCentralAislador+GruesoPrincipal*z, GruesoPrincipal/2
            }
            #else
              union             {
                cylinder        {
                  PuntoCentralAislador,
                  GruesoPrincipal*z,
                  GruesoPrincipal/2
                }
                cylinder        {
                  GruesoPrincipal*z,
                  -PuntoCentralAislador,
                  GruesoPrincipal/2
                }
              }
            #end
            #local C            = 0;
            #while ( C < 4 ) 
              object              {
                FinalPie
                rotate  C*90*z
              } 
              #local C          = C+1;
            #end   
            translate   GruesoPrincipal*z
          }
          texture       {
            ACOC_TexturaMetalicaAislador_1
          }
        }
        translate       -AlturaBase*z
      }
    #break
    #case ( ACOC_Bodegon ) 
      #local RadioImagen        = 70*L;
      #local GruesoImagen       = 1.75*L;
      #local RadioBorde         = 1.75*L;
      #local RadioAislador       = 55*L;
      #local RadioGuiaPatita    = 50*L; 
      #local AlturaAislador      = 9*L;
                 
      #if ( Param1 != 0 )
        #local TexturaImagenSuperficie        = texture       {
          pigment    { 
            image_map        {
              #switch ( Param1 )
                #case ( ACOC_jpeg )
                  jpeg        Param2
                #break
                #case ( ACOC_png  )
                  png         Param2
                #break
                #case ( ACOC_sys  )
                  sys         Param2
                #break
              #end 
            }
          }                 
          normal     { bumps scale 0.3 }
        }
        #local TexturaAisladorPlastico        = texture       {
          pigment    { color Param3 }    
          normal     { bumps scale 0.3 }
        }
      #end
      
      union             {
        cylinder        {
          0.01*GruesoImagen*z   , -GruesoImagen*z       ,
          RadioImagen
        }
        torus           {
          RadioImagen           , RadioBorde
          rotate        -90*x
        }
        union          {
          #local C        = 0; 
          #while ( C < 3 )
          intersection    {
            difference    {
              cylinder    {
                0                   , AlturaAislador*z      ,
                RadioAislador
              }
              cylinder    {
                0                   , AlturaAislador*1.1*z  ,
                RadioAislador-GruesoImagen
              }
            } 
            cylinder    {
              0         , -RadioImagen*y
              RadioGuiaPatita
              translate ( -RadioGuiaPatita+AlturaAislador )*z
              rotate    C*120*z  
            }
          }
          #local C      = C+1;
          #end
        }   
        #if ( Param1 = 0 )
          texture         {
            gradient z    
            texture_map   {
              [ 0.0 ACOC_TexturaAisladorPlastico_2   ]
              [ 0.5 ACOC_TexturaAisladorPlastico_2   ]
              [ 0.5 ACOC_TexturaImagenSuperficie_2  ]
              [ 1.0 ACOC_TexturaImagenSuperficie_2  ]
            }
            translate     -<0.5,0.5,0>
            scale    
              < 2.00*RadioImagen+GruesoImagen, 
                2.00*RadioImagen+GruesoImagen, 5*AlturaAislador >
          }
        #else
          texture         {
            gradient z    
            texture_map   {
              [ 0.0 TexturaAisladorPlastico          ]
              [ 0.5 TexturaAisladorPlastico          ]
              [ 0.5 TexturaImagenSuperficie         ]
              [ 1.0 TexturaImagenSuperficie         ]
            }
            translate     -<0.5,0.5,0>
            scale    
              < 2.00*RadioImagen+GruesoImagen, 
                2.00*RadioImagen+GruesoImagen, 5*AlturaAislador >
          }
        #end
        translate       -AlturaAislador*L
      }
    #break
    #case ( ACOC_Hexagonal )
      #local DistanciaBasico    = Param1;
      #local AnchoBasico        = Param2;
      #local ProfundidadBasico  = Param2;
      #local Co_60              = cos( radians( 60 ) );
      #local Si_60              = sin( radians( 60 ) );
      #local ApotemaHexagono    = AnchoBasico*sqrt( 3 )/2;
      #local ApotemaTriangulo   = AnchoBasico*sqrt( 3 )/6;
      #local DistanciaAxi       = ApotemaHexagono+
                        DistanciaBasico+ApotemaTriangulo; 
      #local Er_X1              = 0.0;
        
      #macro ACOC_Hexagono ( TotalBrazos )
        union           {
          #local C      = 0;
          #while ( C < TotalBrazos )
            object      {
              ACOC_FiguraBasico_3( Param1, Param2 )
              translate ( ApotemaHexagono+DistanciaBasico/2 )*x
              rotate    60*C*z
            }
            #local C    = C+1;
          #end
        }
      #end
          
      #macro ACOC_Borde ()
        object      {
          ACOC_FiguraBasico_3( Param3*Param1, Param2 )
          translate ( ApotemaHexagono+DistanciaBasico/2 )*x
        }
      #end
      
      #macro ACOC_GeneradorRed ( TexturaCentral )    
        union                   {
          object                { 
            ACOC_Hexagono( 1 ) 
            texture             {
              ACOC_TexturaMaderaVerde_3
            }
          }
          object                {
            ACOC_Hexagono( 5 ) 
            rotate              60*z
            translate           DistanciaAxi*<1+Co_60,Si_60,0>
            texture             {
              ACOC_TexturaMaderaAislador_3
            }
          }
          object                {
            ACOC_Hexagono( 6 )                    
            translate           DistanciaAxi*<1+3*Co_60+Er_X1,Si_60,0>
            texture             {
              TexturaCentral
            }
          }
          object                {
            ACOC_Hexagono( 4 )
            translate           DistanciaAxi*<1+2*Co_60,2*Si_60,0>
            texture             {
              ACOC_TexturaMaderaAislador_3
            }
          }
          object                {
            ACOC_Hexagono( 1 )
            rotate      60*z
            translate           DistanciaAxi*<1+4*Co_60,0,0>
            texture             {
              ACOC_TexturaMaderaAislador_3
            }
          }
          object                {
            ACOC_Hexagono( 1 )
            translate           DistanciaAxi*<1+Co_60,3*Si_60,0>
            texture             {
              ACOC_TexturaMaderaAislador_3
            }
          }
          #local C              = 0;
          #while ( C < 4 )
            object              {
              ACOC_Borde()
              rotate            120*z
              translate         DistanciaAxi*<1+(6-C)*Co_60,C*Si_60,0>
              texture           {
                ACOC_TexturaMaderaBorde_3
              }
            }
            #local C            = C+1;
          #end
        }
      #end
      
      union             {
        #local C        = 0;
        #while ( C < 6 )
          object    {
            #if ( mod( C, 2 ) = 0 )
              ACOC_GeneradorRed( ACOC_TexturaMaderaAzul_3 )
            #else
              ACOC_GeneradorRed( ACOC_TexturaMaderaRojo_3 )
            #end
            rotate      C*60*z
          }   
          #local C      = C+1;
        #end 
        translate       -ProfundidadBasico/2*z
      }
      
    #break
  #end
  
#end

#declare ACOC_AisladorMargarita  = object        {
  #local RadioMayorMargarita            = 66*L;
  #local RadioMenorMargarita            = 14.5*L;
  ACOC_AisladorComedorObjetoCaliente( ACOC_Margarita,
        RadioMayorMargarita, RadioMenorMargarita, 1.0 )
}

#declare ACOC_AisladorFlor       = object        {
  #local DiametroGrandeFlor         = 141*L;
  #local DiametroMedianoFlor        = 107*L;
  ACOC_AisladorComedorObjetoCaliente( ACOC_Flor,
        DiametroGrandeFlor, DiametroMedianoFlor, 1.0 )
}

#declare ACOC_AisladorBodegon    = object        {
  ACOC_AisladorComedorObjetoCaliente
        ( ACOC_Bodegon, 0, 0, 0 )
} 

#declare ACOC_AisladorHexagonal  = object        {
  #local DistanciaBasicoHexagonal    = ACOC_DistanciaBasico_3;
  #local AnchoBasicoHexagonal        = ACOC_AnchoBasico_3;
  ACOC_AisladorComedorObjetoCaliente( ACOC_Hexagonal, 
        DistanciaBasicoHexagonal, AnchoBasicoHexagonal, 1.1 )
}
