// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 20 diciembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// Se crean cuatro Aisladors de Comida Caliente para comedor.  Se ubica
// segun las siguientes coordenadas:
// AisladorMargarita
// Radio        = 67.25*L
// Altura       = 16.75*L
// AisladorFlor
// Radio        = 71.75*L
// Altura       = 15.25*L
// AisladorBodegon
// Radio        = 71.75*L
// Altura       = 10.75*L
// AisladorHexagonal
// Radio        ~ 70*L
// Altura       ~ 3.5*L 
// 
// Los cuatro se ubican con la parte inferior centrada en el origen
// y los cuatro apuntan hacia z negativo
// Los objetos respectivos se llaman
// ACOC_AisladorMargarita, ACOC_AisladorFlor, ACOC_AisladorBodegon,
// y ACOC_AisladorHexagonal
// Para su utilizacion simplemente...
// include "ACOC.inc"
// object { ACOC_AisladorFlor }
//
// Similar para los otros. Pueden generarse mediante la macro
// ACOC_AisladorComedorObjetoCaliente( Estilo, Param1, Param2, Param3 )
// Estilo       : los cuatro estilos se identifican con los valores
//              (se indican valores Default)
//      ACOC_Margarita
//              Param1  : radio de circulo mayor, 66*L
//              Param2  : radio de circulo menor, 14.5*L
//              Param3  : cambiar el grueso como fraccion, 1.0 
//      ACOC_Flor
//              Param1  : diametro de circulo mayor, 141*L
//              Param2  : diametro de ciruclo menor, 107*L
//              Param3  : cambiar el grueso como fraccion, 1.0   
//      ACOC_Bodegon
//              Param1  : si 0 utilizar dibujo y textura default
//                        otras opciones es para el tipo de dibujo, 0
//                      ACOC_jpeg       para imagen tipo jpeg
//                      ACOC_png        para imagen tipo png
//                      ACOC_sys        para imagen tipo sys
//              Param2  : archivo de imagen como string
//              Param3  : color de la base inferior
//              Nota: caso default (ACOC_Bodegon,0,"",0)
//                      se exige Param1 = 0 para default
//      ACOC_Hexagonal  
//              Param1  : Largo del elemento basico, 13*L
//              Param2  : Ancho cuadrangular del elemento basico, 3.5*L
//              Param3  : Los elementos del borde, pueden
//                        ser un poco mas grandes de largo, 1.1
// Ejemplo 
// object       {
//   ACOC_AisladorComedorObjetoCaliente
//              ( ACOC_Bodegon, ACOC_png, "mtmandj.png", Cyan )
//                      // mtmandj.png viene con PovRay
// }
// Otros modificadores validos serian:
//    (si se indica es default)
// #declare ACOC_POV3_1 = off;
//      al activarse "on", provoca simplificaciones
//      para que sea compatible con POVRay 3.1.
//      En algunas versiones de POVRay se activa automticamente.
// #declare ACOC_S      = 2234;
//      para semilla aleatoria, util en ACOC_Hexagonal
// #declare ACOC_TexturaMetalicaAislador_0        = texture { ... }
//      Para el Aislador metalico de ACOC_Margarita
// #declare ACOC_TexturaMetalicaAislador_1        = texture { ... }
//      Para el Aislador metalico de ACOC_Flor
// #declare ACOC_TexturaPatitaPlastico_0         = texture { ... }
//      Para la patita plastica de ACOC_Margarita
// #declare ACOC_TexturaPatitaPlastico_1         = texture { ... }
//      Para la patita plastica de ACOC_Flor
// #declare ACOC_TexturaImagenSuperficie_2       = texture { ... }   
//      para redefinir la imagen o lo que se quiera utilizar
//      en la zona plana de ACOC_Bodegon
// #declare ACOC_BodegonImagen  = "ACOC_Bodegon.gif"
//      string para la imagen default, debera ser jpg,
//      util si no se redefine ACOC_TexturaImagenSuperficie_2
//      en el modo ACOC_POV3_1 debera utilizar un tipo gif.
// #declare ACOC_TexturaAisladorPlastico_2        = texture { ... }
//      Textura default de la base del bodegon 
// #declare ACOC_DistanciaBasico_3       =  13*L;
//      Permite cambiar el largo default del elemento basico 
//      de ACOC_Hexagonal
// #declare ACOC_AnchoBasico_3           =  3.5*L;
//      Permite cambiar el ancho cuadrangular default
//      del elemento basico de ACOC_Hexagonal
// #declare ACOC_TexturaHilo_3                   = texture { ... }       
//      Util si no se redifine ACOC_FiguraBasico_3
//      permite cambiar la textura del hilo blanco en ACOC_Hexagonal
// #macro ACOC_FiguraBasico_3 ( Distancia, Ancho )  
//      Redefinible, para ACOC_Hexagonal se supone crea una figura
//      sustituta para el elememento basico hexagonal
//      Distancia es el largobasico de la figura, y Ancho se
//      toma como base cuadrada
// #declare ACOC_TexturaMaderaAislador_3  = texture { ... }
//      Para la textura de madera basica de ACOC_Hexagonal
// #declare ACOC_TexturaMaderaVerde_3    = texture { ... }
//      Para la textura de madera verde en el default, redefina a gusto
// #declare ACOC_TexturaMaderaRojo_3    = texture { ... }
//      Para la textura de madera rojo  en el default, redefina a gusto
// #declare ACOC_TexturaMaderaAzul_3    = texture { ... }
//      Para la textura de madera azul  en el default, redefina a gusto
// #declare ACOC_TexturaMaderaBorde_3   = texture { ... }
//      Permite redefinir la textura del borde de ACOC_Hexagonal
//      por default se define identica a ACOC_TexturaMaderaAislador_3
// 

#include "colors.inc"

#declare ACOC_L                      = 0.001;
#declare ACOC_OjoAbsoluto            = 256*ACOC_L;
#declare ACOC_VecesCentroAbsoluto    = 10;     
camera {
        location <   0,  0, 
        -( ACOC_VecesCentroAbsoluto+1 )*ACOC_OjoAbsoluto >
        look_at  <   0,  0, 
        -ACOC_VecesCentroAbsoluto*ACOC_OjoAbsoluto >
}         
light_source    {
         < 500  , 500   , -3000 >*ACOC_L
         White
}
light_source    {
         <-500  ,-500   , -3000 >*ACOC_L
         White
}
background      {
         Gray50
}       

#include "ACOC.inc"

    
object  {
  ACOC_AisladorMargarita 
  translate    < 100, 100, 0 >*ACOC_L 
  translate     -0.95*( ACOC_VecesCentroAbsoluto )*ACOC_OjoAbsoluto*z
}     

object  {
  ACOC_AisladorFlor 
  translate    <-100, 100, 0 >*ACOC_L 
  translate     -0.95*( ACOC_VecesCentroAbsoluto )*ACOC_OjoAbsoluto*z
} 

object  {
  ACOC_AisladorBodegon   
  translate    < 100,-100, 0 >*ACOC_L 
  translate     -0.95*( ACOC_VecesCentroAbsoluto )*ACOC_OjoAbsoluto*z
}

object  {
  ACOC_AisladorHexagonal
  translate    <-100,-100, 0 >*ACOC_L 
  translate     -0.95*( ACOC_VecesCentroAbsoluto )*ACOC_OjoAbsoluto*z
}    

