// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 11 setiembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// El objeto AHSV_Arbol1 (ArbolSimpleHojaVerde) se coloca 
// en con su base centro inferior en <0,0,0>
//      
// Altura unos 10000*L
// ubicando un area de unos 5000L*5000L       
//
// como modificador
// #declare ASHV_MoteteHojasExtra        = off;
// que sustituye las Hojas por esferas de rpido "parse"
// pero debe ubicarse antes del include "ArbolHSV.inc"
//
// Para colocarlo simplemente 
// object { AHSV_Arbol1 }  

#include "colors.inc" 
#include "woods.inc" 
#include "textures.inc"
#include "functions.inc"

#local   L              = 0.001;                         
  
//  crea con object { Arbol1 } un arbol de 10000L de alto
//  con la zona inferior en 0
#ifndef ( ASHV_MoteteHojasExtra )
  #declare   ASHV_MoteteHojasExtra     = true;      
#end
#local   DesviacionLongitudTronco       = 0.20;
#local   DesviacionGruesoTronco         = 0.05;
#local   DesviacionAnguloFi             = 0.20;
#local   DesviacionAnguloPlano          = 0.20;
#local   DesviacionMoteteHojas          = 0.40;
#local   S                              = seed( 10 );  
#local   Texture1Hoja   = texture       {
        pigment         { 
                bozo
                turbulence      0.3
                color_map       {
                        [ 0.0 color LimeGreen    ]
                        [ 0.5 color ForestGreen  ]
                        [ 0.5 rgbt 1 ]
                        [ 1.0 rgbt 1 ]
                }
        }
}
#local   Texture2Hoja   = texture       {
        pigment         { rgbt 1 }
}
#if ( ASHV_MoteteHojasExtra = true )                          
        #local   MoteteHojas    = isosurface      {           
                function        { f_noise3d( 5*x, 5*y, 5*z )-0.5 }
                contained_by    { sphere        { 0, 1.00 } }
                texture         {  
                        onion   
                        texture_map          {
                                [ 0   Texture1Hoja ]
                                [ 0.8 Texture1Hoja ]
                                [ 0.8 Texture2Hoja ]
                                [ 1   Texture2Hoja ]
                        }         
                }                         
                scale           < 1.5,    1.5     , 1.5 >
                scale           100* 
                         ( 1+DesviacionMoteteHojas*( rand( S )-0.5 ) )*L
        }
#else //MoteteHojasExtra false
        #local   MoteteHojas    = union         {
                sphere          {
                        0       ,                     
                        100*( 1+DesviacionMoteteHojas*( rand( S )-0.5 ) )*L
                }
                pigment         { Green }
        }
#end
#local   RamaGrande             = union         {
        #local   Longitud       = 300*L;
        #local   Grueso         = 5*L;
        #local   AnguloFi       = 30;
        #local   Num_Ramas      = 4;
        
        #local   A                = 0;
        #local   AnguloInicial    = 360*rand( S );        
        #while ( A < Num_Ramas )
                union           {           
                        #local   LongActual       = Longitud*
             ( 1+DesviacionLongitudTronco*( rand( S )-0.5 ) );
                        object          {
                                MoteteHojas
                                translate       LongActual*y
                        }
                        cylinder        {
                                0       , LongActual*y,
                                Grueso*
                          ( 1+DesviacionGruesoTronco*( rand( S )-0.5 ) )
                                texture         { Dark_Wood }
                        }
                        rotate          z*AnguloFi*
                          ( 1+DesviacionAnguloFi*( rand( S )-0.5 ) )
                        rotate          y*AnguloInicial
                         
                }
                #local   AnguloInicial    = AnguloInicial+                 
       ( 360/Num_Ramas )*( 1+DesviacionAnguloPlano*( rand( S )-0.5 ) ); 
                #local   A                = A+1;
        #end
}                  

#local   RamaGrande2            = union         {
        #local   Longitud       = 300*L;
        #local   Grueso         = 15*L;
        #local   AnguloFi       = 30;
        #local   Num_Ramas      = 4;
        
        #local   A                = 0;
        #local   AnguloInicial    = 360*rand( S );
        #while ( A < Num_Ramas )
                union           {           
                        #local   LongActual       = Longitud*
             ( 1+DesviacionLongitudTronco*( rand( S )-0.5 ) );
                        object          {
                                RamaGrande
                                translate       LongActual*y
                        }
                        cylinder        {
                                0       , LongActual*y,
                                Grueso*
                          ( 1+DesviacionGruesoTronco*( rand( S )-0.5 ) )
                        texture         { Dark_Wood }
                        }
                        rotate          z*AnguloFi*
                          ( 1+DesviacionAnguloFi*( rand( S )-0.5 ) )
                        rotate          y*AnguloInicial
                         
                }
                #local   AnguloInicial    = AnguloInicial+                 
       ( 360/Num_Ramas )*( 1+DesviacionAnguloPlano*( rand( S )-0.5 ) ); 
                #local   A                = A+1;
        #end
}

#local   RamaGrande3            = union         {
        #local   Longitud       = 300*L;
        #local   Grueso         = 25*L;
        #local   AnguloFi       = 50;
        #local   Num_Ramas      = 4;
        
        #local   A                = 0;
        #local   AnguloInicial    = 360*rand( S );        
        #while ( A < Num_Ramas )
                union           {           
                        #local   LongActual       = Longitud*
             ( 1+DesviacionLongitudTronco*( rand( S )-0.5 ) );
                        object          {
                                RamaGrande2
                                translate       LongActual*y
                        }  
                        cylinder        {
                                0       , LongActual*y,
                                Grueso*
                          ( 1+DesviacionGruesoTronco*( rand( S )-0.5 ) )
                        texture         { Dark_Wood }
                //                pigment         { Brown }
                        }    
                        rotate          z*AnguloFi*
                          ( 1+DesviacionAnguloFi*( rand( S )-0.5 ) )
                        rotate          y*AnguloInicial
                         
                }
                #local   AnguloInicial    = AnguloInicial+                 
       ( 360/Num_Ramas )*( 1+DesviacionAnguloPlano*( rand( S )-0.5 ) ); 
                #local   A                = A+1;
        #end
}
                    
#local   RamaGrande4            = union         {
        #local   Longitud       = 300*L;
        #local   Grueso         = 50*L;
        #local   AnguloFi       = 50;
        #local   Num_Ramas      = 4;
        
        #local   A                = 0;
        #local   AnguloInicial    = 360*rand( S );        
        #while ( A < Num_Ramas )
                union           {           
                        #local   LongActual       = Longitud*
             ( 1+DesviacionLongitudTronco*( rand( S )-0.5 ) );
                        object          {
                                RamaGrande3
                                translate       LongActual*y
                        }
                        cylinder        {
                                0       , LongActual*y,
                                Grueso*
                          ( 1+DesviacionGruesoTronco*( rand( S )-0.5 ) )
                                texture         { Dark_Wood }
                        }
                        rotate          z*AnguloFi*
                          ( 1+DesviacionAnguloFi*( rand( S )-0.5 ) )
                        rotate          y*AnguloInicial
                         
                }
                #local   AnguloInicial    = AnguloInicial+                 
       ( 360/Num_Ramas )*( 1+DesviacionAnguloPlano*( rand( S )-0.5 ) ); 
                #local   A                = A+1;
        #end
}
#local   Texture2Tronco         = texture       {
        pigment         {
                gradient x
                scale   0.01
                turbulence  0.5     
                pigment_map     {
                        [ 0.00 rgbt 1 ]
                        [ 0.85 rgbt 1 ]
                        [ 0.85 rgb Black ]
                        [ 1.00 rgb Black ]
                }
        }
} 
#declare   ASHV_Arbol1         = union         {                    
        object          { RamaGrande4 }
        union           {
                difference      {
                  sphere_sweep    {
                        cubic_spline      
                        8,
                        < 0,-1100,0>*L,140*L
                        < 0,-1000,0>*L,140*L
                        #local   A      = 2;
                        #while ( A < 8 )
                          < rand( S )*20-10     , -1100+1200*( A )/6, rand( S )*20-10 >*L, 100*(1+0.10*( rand(S)-0.5 ) )*L
                          #local   A           = A+1;                                                                 
                        #end
                  }
                  plane   { y, -1000*L }
                }
                sphere_sweep    {
                        cubic_spline
                        5,
                        < 750, 200, 0 >*L, 50*L
                        < 500, 0 , 0  >*L, 40*L
                        < 100, -300, 30 >*L, 30*L
                        <  0  , -500, 0>*L, 50*L
                        < -100, -600, 0>*L, 50*L
                }
                isosurface      {      
                        function        { y-0.3*f_noise3d( 7*x, 0, 7*z )
                                +0.4*( sqrt( x*x+z*z ) ) }
                        contained_by    { box { <-1,0,-1> , 1 }}
                        translate       -1*y
                }       
                texture         { Dark_Wood }
                texture         { Texture2Tronco }
                normal          { 
                        ripples         0.75
                        frequency       2
                        turbulence      0.3
                        normal_map      {
                                [ 0 granite              ]
                                [ 1 bumps   1 scale 0.2  ]
                        }
                }
        }
        translate       +y 
        scale           5
}
 
    
