// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 30 diciembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// Se crean cuatro esquineros simples de hogar.  Se ubican
// segun la siguiente descripcion:
// EsquineroMetalTriple
// RadioPlano           = 215*L
// Radio                = 217*L
// Alto                 = 890*L
// PrimerNivel          = 112*L
// SegundoNivel         = 441*L
// TercerNivel          = 777*L
// CadaNivelAdicional   = 336*L  
//      El objeto se ubica orientado hacia x+ z-, <1,0,-1>
//      el origen en la parte inferior, al vertice del cuadrante
// EsquineroPlasticoTriple
// RadioPlano           = 130*L
// Radio                = 148*L
// Alto                 = 552*L
// PrimerNivel          = 108.5*L
// SegundoNivel         = 322.5*L
// TercerNivel          = 536.5*L
// CadaNivelAdicional   = 214*L  
//      El origen en la parte inferior centrada
//      las patas alineadas en paralelo a los ejes x y z
// EsquineroVidrioPisoSimple
// Radio                = 160*L
// RadioLibre           = 113*L
// Alto                 = 362.5*L
//      El origen en la parte inferior centrada
//      los laterales orientados paralelos a los ejes x y z
// EsquineroVidrioDobleAlto
// RadioPlano           = 360*L
// Radio                = 377*L
// Alto                 = 32*L
// PrimerNivel          = 17*L
// SegundoNivel         = 317*L
// CadaNivelAdicional   = 300*L
// Altura Recomendada   = 875*L (translate 875*L*y Ver macro)
//      El objeto se ubica orientado hacia x+ z-, <1,0,-1>
//      el origen en la parte inferior, al vertice del cuadrante
//      mas 875*L*y optativo
// 
// Los objetos respectivos se declaran como macros
// EHEV_EsquineroMetalTriple()
// EHEV_EsquineroPlasticoTriple()
// EHEV_EsquineroVidrioPisoSimple()
// EHEV_EsquineroVidrioDobleAlto( BanderaAlto )
//      BanderaAlto     : si TRUE aplica translate 875*L*y
// Para su utilizacion simplemente...
// include "EsquineroHEV.inc" 
// object { EHEV_EsquineroMetalTriple() } 
//
// o bien este otro ejemplo...
// object { EHEV_EsquineroVidrioDobleAlto( true ) }
//
// Los objetos tambien pueden generarse y alterarse mediante
// un llamado directo a la macro general
// EHEV_EsquineroHogarEspacioVacio 
//        ( Estilo, Param1, Param2, Textura1, Textura2, Material1 )
// Estilo       : los cuatro estilos se identifican con los valores
//        ( se indican valores Default )
//      EHEV_MetalTriple
//              Param1          : radio del esquinero, 215*L 
//              Param2          : 0 o mas pisos adicionales a tres, 
//                                      default 0
//              Textura1        : se aplica a los soportes metalicos
//                                      del vidrio,
//                                      EHEV_TexturaMetalTriple
//              Textura2        : se aplica texture a las figuras "S" 
//                                      decorativas y a la barra,
//                                      EHEV_TexturaSMetalTriple
//              Material1       : se aplica material al vidrio
//                                      EHEV_VidrioMetalTriple
//      EHEV_PlasticoTriple
//              Param1          : diametro plano del esquinero, 260*L 
//              Param2          : total de pisos, 3
//              Textura1        : se aplica texture al soporte que rodea
//                                      al circulo central,
//                                      EHEV_TexturaPlasticoTriple
//              Textura2        : se aplica texture a las patas, incluye
//                                      el exceso final hacia y+, 
//                                      EHEV_TexturaPatasPlasticoTriple
//              Material1       : se aplica material al circulo central
//                                      EHEV_MaterialPlasticoTriple
//      EHEV_VidrioPisoSimple
//              Param1          : permite colocar "mal" el vidrio 
//                                      agregando un rotate Param1*y luego
//                                      se aplica Param2, 0 
//              Param2          : permite colocar "mal" el vidrio
//                                      agregando translate Param2*<1,0,1>
//                                      se ignora y, <0,0,0>
//              Textura1        : se aplica texture a las partes doradas 
//                                      de la base,
//                                      EHEV_TexturaDoradaVidrioPisoSimple
//              Textura2        : se aplica texture a las patas en 
//                                      zona negra
//                                      EHEV_TexturaNegraVidrioPisoSimple
//              Material1       : se aplica material al vidrio
//                                      EHEV_MaterialVidrioPisoSimple
//      EHEV_VidrioDobleAlto
//              Nota: esta macro no aplica el translate 875*L*y,
//                      de la macro EHEV_EsquineroVidrioDobleAlto( true )
//              Param1          : grosor del soporte de madera, 32*L 
//              Param2          : total de pisos, 2
//              Textura1        : se aplica texture al soporte que rodea
//                                      al vidrio,
//                                      EHEV_TexturaVidrioDobleAlto
//              Textura2        : se aplica texture a la esfera que
//                                      finaliza los soportes,
//                                      EHEV_TexturaEsferaVidrioDobleAlto
//              Material1       : se aplica material al vidrio,
//                                      EHEV_MaterialVidrioDobleAlto 
// Ejemplo 
// object       {
//   EHEV_EsquineroHogarEspacioVacio
//      ( EHEV_PlasticoTriple, 500*L, 2, texture { PinkAlabaster },
//                texture { PinkAlabaster }, 
//                material { texture { PinkAlabaster} } )
// }  
// Para el diseo de su dibujo, la macro genera automaticamente
// las siguientes variables
// EHEV_TotalPisos      : indica el total de pisos de la figura
// EHEV_AlturaPisos     : array, indice de 0 hasta EHEV_TotalPisos-1,
//      que indica la altura de superficie del piso
// Se borran y reescriben con cada llamado a la macro  
// Nota: el tipo EHEV_EsquineroVidrioPisoSimple solo define un piso
// Ejemplo (coloca el cilindro sobre el esquinero)
// include "EsquineroHEV.inc"
// union       {
//   object { EHEV_EsquineroVidrioPisoSimple() }
//   cylider    { 
//     0, 0.01, 0.01 
//     translate EHEV_AlturaPisos[ 0 ]*y
//     pigment { Red }  
//   } 
// }
//
// Otros modificadores validos redefinibles serian:
//    (si se indica es default)
//      La mayoria de estas texturas se aplicarian si se
//      utiliza el objeto default   
// #declare EHEV_POV3_1                         = off;
//      Al activarse permite compatibilidad con POVRay 3.1.
//      En algunas versiones POVRay podra activarse automticamente.
// #declare EHEV_TexturaMetalTriple             = texture      { ... }
//      Se aplica al soporte que rodea y sostiene el vidrio
//      en esquinero tipo EHEV_MetalTriple
// #declare EHEV_TexturaSMetalTriple            = texture      { ... }
//      Se aplica a las "S" decorativas 
//      y la barra en tipo EHEV_MetalTriple
// #declare EHEV_VidrioMetalTriple              = material     { ... }
//      Se aplica al vidrio en EHEV_MetalTriple
// #declare EHEV_TexturaPlasticoTriple          = texture      { ... }
//      Se aplica al soporte tipo toroidal que rodea el centro plano
//      en el tipo EHEV_PlasticoTriple
// #declare EHEV_TexturaPatasPlasticoTriple     = texture      { ... } 
//      Se aplica a las patas y final de patas en
//      tipo EHEV_PlasticoTriple
// #declare EHEV_MaterialPlasticoTriple         = material     { ... }
//      Se aplica al centro plano de los soportes
//      en tipo EHEV_PlasticoTriple
// #declare EHEV_MaterialVidrioPisoSimple       = material     { ... }
//      Se aplica al vidrio del tipo EHEV_VidrioPisoSimple
// #declare EHEV_TexturaDoradaVidrioPisoSimple  = texture      { ... } 
//      Se aplica a la zona dorada del tipo EHEV_VidrioPisoSimple
// #declare EHEV_TexturaNegraVidrioPisoSimple   = texture      { ... }
//      Se aplica a la zona negra del tipo
//      EHEV_VidrioPisoSimple
// #declare EHEV_ColorMaderaVidrioDobleAlto     = White;
//      Para cambiar el color, pero mantener textura del soporte
//      en el tipo EHEV_VidrioPisoSimple, util si no se redefine
//      EHEV_TexturaSoporteVidrioDobleAlto
// #declare EHEV_MaterialVidrioDobleAlto        = material     { ... }
//      Para aplicar al vidrio
//      en EHEV_VidrioDobleAlto
// #declare EHEV_TexturaSoporteVidrioDobleAlto  = texture      { ... }
//      Para aplicar a los soportes en EHEV_VidrioDobleAlto,
//      si solo se quiere cambiar el color (por ejemplo pared Blue),
//      se recomienda usar EHEV_ColorMaderaVidrioDobleAlto (mas facil)
// #declare EHEV_TexturaEsferaVidrioDobleAlto   = texture      { ... }
//      Para aplicar a la esfera final del soporte de madera
//      en tipo EHEV_VidrioDobleAlto
// Ejemplo:
// #declare EHEV_ColorMaderaVidrioDobleAlto     = Orange;
// include "EsquineroHEV.inc"
// object { EHEV_EsquinerVidrioDobleAlto( true ) }      
//  

#include "colors.inc"
#include "EHEV.inc"  

#declare EjeMejorado            = false;
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;

camera {
        location <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L  
}         
light_source    {    
         < 500  , 500   , -3000 >*L          
         0.8*White
         area_light < 200, 0, 0 >*L, <0, 0, 200>*L, 5, 5 
         adaptive 1
         jitter
}
light_source    {    
         < -500  , 500   , -3000 >*L          
         0.8*White
         area_light < 200, 0, 0 >*L, <0, 0, 200>*L, 5, 5 
         adaptive 1
         jitter
}
background      {
         Gray50
}
    
object  {
  EHEV_EsquineroMetalTriple()
  rotate        45*y
  translate    -800*L*x-700*L*y-800*L*z
  #debug "Pisos\n"   
  #debug concat( str( EHEV_TotalPisos, 0, 3 ), "\n" )
}

object  {
  EHEV_EsquineroPlasticoTriple()
  rotate        45*y
  translate    -700*L*y-800*L*z
  #debug concat( str( EHEV_TotalPisos, 0, 3 ), "\n" )
}

object  {
  EHEV_EsquineroVidrioPisoSimple()
  rotate        45*y
  translate     800*L*x-700*L*y-800*L*z
  #debug concat( str( EHEV_TotalPisos, 0, 3 ), "\n" )
}

object  {
  EHEV_EsquineroVidrioDobleAlto( true ) 
  rotate        45*y
  translate    -700*L*y-800*L*z
  #debug concat( str( EHEV_TotalPisos, 0, 3 ), "\n" )
}