// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 20 agosto 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
//  
// El objeto fuente se coloca 
// con su base centrada en <0,0,0>
// Radio es 2200*L
// Altura es menor de 2500*L       
// Para colocarlo simplemente 
// object { FBAR_FuenteBAR }
// FBAR : FuenteBonitaAnimeShoujo
// Recomendado aumentar max_trace_level, de lo contrario
// aparecen manchas oscuras
//
// El objeto CirculoPiedra es algo "trivial"
// se coloca con base centrada en <0,0,0>
// radio es 500*L, y altura 100*L 
//
// El zacate se genera centrado en la base <0,0,0>
// con la orden 
// object{ FBAR_CespedCrackle(Dx,Dy,Dz,densidad) }
// es un cubo de zacate Dx*Dy*Dz (arriba es y)
// un buen valor de densidad es 0.3
// Los modificadores permitidos 
// #declare FBAR_POV3_1
//    activa el modo POVRAY3_1 que lo vuelve compatible
//    con POVRAY3_1, sirve para los usuarios del FREEDos
//    que utilicen versiones anteriores, tambin
//    acelera el "render" con prdida de calidad.
//    Probablemente se active automticamente en algunas
//    versiones de POVRay.
// #declare FBAR_CespedCrackle   = off;      
//    desaparece el csped de FBAR_CespedCrackle
//    y permanece un rectngulo verduzco,
//    on por default.
// #declare FBAR_ActivarGotitas = off;
//    genera un dibujo de fuente ms simple y rpido
//    on por default. 
// #declare FBAR_TexturaHojaCesped      = texture { ... }
//    para cambiar el tipo de Hoja de Cesped
// #declare FBAR_TexturaBaseCesped      = texture { ... }
//    para cambiar la textura en el suelo base del Cesped 
// Nota: es posible que convenga cambiar la textura del csped
//    pues el mismo se creo pensando en la escena y no en
//    una aplicacin general.                    
//

#include "textures.inc"
#include "stones.inc"

#declare FBAR_L                         = 0.001;

#ifndef ( FBAR_POV3_1 )                       
  #if ( version < 3.2 )
    #declare FBAR_POV3_1                = on;
  #else
    #declare FBAR_POV3_1                = off;
  #end
#end    

#if ( FBAR_POV3_1 )
  #declare FBAR_CespedCrackle           = off;
  #declare FBAR_ActivarGotitas          = off;        
#else
  #include "functions.inc"
#end

// Esta macro crea cesped centrado en <0,0,0>
// se supone orientado hacia y (Profundidad)
// esta diseado para trabajar con unidades L
// un zacate espesito se obtiene con densidad 0.30  
// la variable FBAR_CespedCrackle = off provoca solo dibujar piso plano
#ifndef ( FBAR_CespedCrackle )
  #declare FBAR_CespedCrackle   = on;      
#end
#ifndef ( FBAR_ActivarGotitas )
  #declare FBAR_ActivarGotitas         = on;
#end    

#macro FBAR_CuboCesped ( LargoX, Profundidad, LargoZ, Densidad )     
#if ( FBAR_POV3_1 = off )
#local fn_Crack=
  function {
    pigment {
      crackle
      form <-Densidad,0,0.9>
      color_map { [0 rgb 0][1 rgb 1] }
      scale 0.9
    }
  } 
#end 
union           { 
  #if ( FBAR_CespedCrackle )
  isosurface    {
    function { (fn_Crack(x/.1, y/.1, z/.1).gray-0.5) }
    max_gradient          1.4
    accuracy 0.005            
    contained_by { box { <-0.5*LargoX,-1.0*Profundidad*4,-0.5*LargoZ>,
                  <0.5*LargoX,1.0*Profundidad*4,0.5*LargoZ> } }
    #ifndef ( FBAR_TexturaHojaCesped )
    texture {
      pigment { rgb <0.2, 0.8, 0.5> }
      finish {
        specular 0.5
        roughness 0.04
        diffuse 0.8
        brilliance 2.0
        ambient 0.1
      }
    }
    #else
      texture   {
        FBAR_TexturaHojaCesped
      }
    #end
    scale         < 1     , 0.5*Profundidad     , 1   >
  }
  #end

  polygon       {
    5,
    <-0.5*LargoX,-0.5*LargoZ>,
    <-0.5*LargoX, 0.5*LargoZ>,
    < 0.5*LargoX, 0.5*LargoZ>,
    < 0.5*LargoX,-0.5*LargoZ>,
    <-0.5*LargoX,-0.5*LargoZ>
    #ifndef ( FBAR_TexturaBaseCesped )
    pigment     {
      DarkOliveGreen
    }           
        finish          { 
                ambient 0.5
                diffuse 0.1
                phong 0
                specular 0 
        }
    #else    
      texture   {
        FBAR_TexturaBaseCesped
      }
    #end
    rotate      90*x
    translate   -0.5*Profundidad*y
  }
}
#end
// #macro FBAR_CuboCesped
  
// para su uso simplemente 
// object { Fuente }
#declare       FBAR_FuenteBAR         = union { 
  #if ( FBAR_POV3_1 = off )
  #macro   FBAR_gotitas ( DensidadGotas, Altura, Grueso )
  isosurface      {               
        function        {
                f_noise3d( x*2/Grueso, y*2/Grueso, z*2/Grueso )-0.5
        }     
        threshold       0
        open
        contained_by     {
                box          {
                        < -Grueso/2, -Altura/2, -Grueso/2 >,
                        <  Grueso/2,  Altura/2,  Grueso/2 >     
                 }      
        }
        pigment         { 
                cells 
                  
                scale   0.1/2*Grueso
                color_map       {  
                        [ 0.0           rgbt < 0.8, 0.8, 1.0, 0.5 > ]
                        [ DensidadGotas rgbt < 1.0, 1.0, 1.0, 0.5 > ]
                        [ DensidadGotas rgbt 1                      ]
                }  
        }
        finish          {         
                ambient         .6
                phong           0.5
                phong_size      20
        }    
        rotate          90*x
        scale           0.3
  } 
  #end
  #end

  #local    TiempoCiclicoTotal     = 1000;
  #local    Aceleracion    = -0.0106*FBAR_L;
  #local    AlturaInicialY = 1000*FBAR_L;
  #local    VInicialY      = 5*FBAR_L;
  #local    VInicialX      = 0.5*FBAR_L;
  #local    RDispersoMin   = 40*FBAR_L;
  #local    RDispersoMax   = 1000*FBAR_L;
  #local    R_DensoMin     = 0.10;
  #local    R_DensoMax     = 1.50;
      
  #if ( FBAR_POV3_1 = off )                              
  #local    F_Disper       = function ( T )        {
    max( RDispersoMin+T*( RDispersoMax-RDispersoMin )/TiempoCiclicoTotal,
        RDispersoMin )
  }    
  #local    F_DensoFuente  = function ( T )        {
    max( min( R_DensoMax+T*( R_DensoMin-R_DensoMax )/TiempoCiclicoTotal,
        1.00 ), R_DensoMin )
  }
  #end                       
  #macro    F_Trayecto_R( T )        
        RDispersoMin+VInicialX*T    
  #end
  #macro    F_Trayecto_H( T )        
        VInicialY*T+Aceleracion*T*T/2+AlturaInicialY        
  #end

  lathe           {  
        quadratic_spline
        5,                          
        < F_Trayecto_R( -TiempoCiclicoTotal/2   ),
          F_Trayecto_H( -TiempoCiclicoTotal/2   ) >,
        < F_Trayecto_R( 0                       ),
          F_Trayecto_H( 0                       ) >,
        < F_Trayecto_R( +TiempoCiclicoTotal/2   ),
          F_Trayecto_H( +TiempoCiclicoTotal/2   ) >,
        < F_Trayecto_R( +TiempoCiclicoTotal*1   ),
          F_Trayecto_H( +TiempoCiclicoTotal*1   ) >,
        < F_Trayecto_R( +TiempoCiclicoTotal*1.5 ),
          F_Trayecto_H( +TiempoCiclicoTotal*1.5 ) > 
        pigment         { 
                rgbt 0.95                 
        }
        normal          {
                gradient        y
                turbulence      0.2   
        }
        finish          {
                reflection      0.05
        }   
        translate       3000*FBAR_L*z
  }   
    
#if ( FBAR_ActivarGotitas )
  #local       TFuente        = 1000; 
  #local       Sita           = 0;
  #while ( Sita < 360 )
        #local       TiempoMovibleFuente            = 
                        -TiempoCiclicoTotal;
        #local       IntervaloTMF                   = 80;
                                                    
        #while ( TiempoMovibleFuente <  2000 )
                #if ( ( TiempoMovibleFuente >= -100 ) & 
                        ( TiempoMovibleFuente <= 1200 ) )
                        
    object {      FBAR_gotitas( F_DensoFuente( TiempoMovibleFuente ), F_Disper( TiempoMovibleFuente ), 1.5 ) 
        translate       
        < F_Trayecto_R( TiempoMovibleFuente ),  F_Trayecto_H( TiempoMovibleFuente ), 0 >
        rotate          Sita*y 
    //    rotate          -20*x+20*y
        translate       
        < 0,  0, 3000*FBAR_L  >
  }
                #end                                    
                #local       TiempoMovibleFuente    =
                                TiempoMovibleFuente+IntervaloTMF;
        #end
  #local       Sita           = Sita+20;
  #end
#end

  // Textura L_Water modificada desde textures.inc 
  // no original...
  #local       L_Water =
  texture {
    pigment{ rgbf <0.6, 0.6, 1.0, 0.75> }
    normal {   
        ripples 0.75
        frequency 10
    }

    finish {
        reflection
        #if ( FBAR_POV3_1 = off )
          {0.3, 1 fresnel}
          conserve_energy
        #end
    }

  }
  #local       L_Water_Int =
  interior {
    ior 1.33
  }

  #local       L_M_Water =
  material {
    texture {L_Water}
    interior {L_Water_Int}
  }
  #local       TextTrans      = pigment       {
        rgbt 1
  }
  #local       TextBurbuja    = pigment       {
        crackle
          #if ( FBAR_POV3_1 = off )
            form    <-1     , 1     , 0     >
          #end
        scale           0.05
        color_map       {
                [ 0.0 color rgbt <1,1,1,0.7> ]
                [ 1.0 color rgbt <0,0,1,0.7> ]
        }
  }
  lathe           {
        cubic_spline
        10,
        <-100   , 0     >*FBAR_L,
        < 0     , 0     >*FBAR_L,
        < 555   ,-100   >*FBAR_L,
        < 700   , 0     >*FBAR_L,
        <1000   , 0     >*FBAR_L,
        <1110   ,-500   >*FBAR_L,
        <1200   ,-500   >*FBAR_L,
        <2000   ,-500   >*FBAR_L,
        <2050   ,-1000  >*FBAR_L,
        <2050   ,-1100  >*FBAR_L
        material         { L_M_Water }  
 
        pigment         {
                wood    
                turbulence 0.08
                pigment_map     {
                        [ 0.0 TextTrans   ]
                        [ 0.5 TextTrans   ]
                        [ 0.5 TextBurbuja ]
                        [ 0.6 TextBurbuja ]
                        [ 0.6 TextTrans   ]
                        [ 0.9 TextTrans   ]
                        [ 0.9 TextBurbuja ]
                        [ 1.0 TextBurbuja ]
                }  
                rotate  90*x
                scale   1.5
         }
        translate       3000*z*FBAR_L
  }
 
  union           { 
        cylinder        {
                0       ,-1000*FBAR_L*y      , 1000*FBAR_L  
        }
        difference      {
                cylinder        {
                        -400*FBAR_L*y        ,-1000*FBAR_L*y      , 2200*FBAR_L
                }
                cylinder        {
                        -390*FBAR_L*y        ,-1001*FBAR_L*y      , 2000*FBAR_L
                }           
        }
        texture         {
                brick                
                texture { pigment         { White_Marble } }
                texture { pigment         { Red_Marble } }      
               
                scale    0.02
        }  
        translate               3000*z*FBAR_L
  }  
  // Advertencia
  // este Pez no tiene aletas laterales ni boca, lo siento...
  // su version original la utilice para una Pecera a "oscuras"
  #local       Pez    = union         {
        blob            {
                threshold      .65 
                cylinder       {
                        <-200  , 0     ,  0    >,
                        < 200  , 0     ,  0    >, 110  ,1     
                }                              //      lower pinky       
                cylinder       {
                        <-150  , 35    ,  0    >,
                        < 150  , 35    ,  0    >,  80  ,1     
                }                              //      lower pinky       
                cylinder       {
                        <-150  , -35   ,  0    >,
                        < 150  , -35   ,  0    >,  80  ,1     
                }                              //      lower pinky       
                cylinder       {
                        <-100  , 70    ,  0    >,
                        < 100  , 70    ,  0    >,  70  ,1     
                }                              //      lower pinky       
                cylinder       {
                        <-100  ,-70    ,  0    >,
                        < 100  ,-70    ,  0    >,  70  ,1     
                }                              //      lower pinky       
                cylinder       {
                        <- 70  ,  85   ,  0    >,
                        <  70  ,  85   ,  0    >,  40  ,1     
                }                              //      lower pinky   
                cylinder       {
                        <- 70  , -85   ,  0    >,
                        <  70  , -85   ,  0    >,  40  ,1     
                }     
                pigment { White_Marble 
                        scale   10
                }
                                         //      lower pinky   
        }
        #local       B11    = < 0   ,-2     , 0     >; 
        #local       B12    = < 0   ,-1     , 0     >; 
        #local       B13    = < 0   , 1     , 0     >;
        #local       B14    = < 0   , 2     , 0     >;      // row 1
        #local       B21    = < 2   ,-4     , 0     >; 
        #local       B22    = < 2   ,-1     , 1     >; 
        #local       B23    = < 2   , 1     ,-1     >;
        #local       B24    = < 2   , 4     , 0     >;      // row 2
        #local       B31    = < 5.5 ,-7     , 0     >; 
        #local       B32    = < 3.25,-6     , 0     >; 
        #local       B33    = < 4   , 5     , 0     >;
        #local       B34    = < 5   , 6     , 0     >;      // row 3
        #local       B41    = < 8   ,-9     ,-2     >; 
        #local       B42    = < 3   ,-5     , 1     >; 
        #local       B43    = < 5   , 5     , -1    >;
        #local       B44    = < 8   , 8     , 2     >;      // row 4
        bicubic_patch   {
                 type           1
                 flatness       0.001
                 u_steps        4
                 v_steps        4
                 #if ( FBAR_POV3_1 = off )
                   uv_vectors
                   < 0    , 0     >
                   < 1    , 0     >
                   < 1    , 1     >
                   < 0    , 1     >
                 #end
                 B11,   B12     , B13   , B14
                 B21,   B22     , B23   , B24
                 B31,   B32     , B33   , B34
                 B41,   B42     , B43   , B44
                 #if ( FBAR_POV3_1 = off )
                   uv_mapping
                 #end
                 texture        {
                        pigment { White_Marble }
                 }
                 scale          25
                 translate      220*x
        }     
        #local       B11    = < 0   , 0     , 0     >; 
        #local       B12    = < 1   , 0     , 0     >; 
        #local       B13    = < 3   , 0     , 0     >;
        #local       B14    = < 4   , 0     , 0     >;      // row 1
        #local       B21    = < 0.2 , 1     , 0     >; 
        #local       B22    = < 2   , 1     , 0     >; 
        #local       B23    = < 3.5 , 1     , 0     >;
        #local       B24    = < 4.8 , 1     , 0     >;      // row 2
        #local       B31    = < 1.5 , 2.5   , 0     >; 
        #local       B32    = < 3   , 2     , 0     >; 
        #local       B33    = < 4.5 , 2     , 0     >;
        #local       B34    = < 6.8 , 2     , 0     >;      // row 3
        #local       B41    = < 2.5 , 3     , 0     >; 
        #local       B42    = < 4   , 3     , 0     >; 
        #local       B43    = < 6   , 3     , 0     >;
        #local       B44    = < 7   , 5     , 0     >;      // row 4
        #local       AletaLateral   = bicubic_patch         {
                 type           1
                 flatness       0.001             
                 u_steps        4
                 v_steps        4
                 #if ( FBAR_POV3_1 = off )
                   uv_vectors
                   < 0    , 0     >
                   < 1    , 0     >
                   < 1    , 1     >
                   < 0    , 1     >
                 #end
                 B11,   B12     , B13   , B14
                 B21,   B22     , B23   , B24
                 B31,   B32     , B33   , B34
                 B41,   B42     , B43   , B44
                 #if ( FBAR_POV3_1 = off )
                   uv_mapping
                 #end
                 scale          25
                 no_shadow  
        }
        union           {           
                object          {    
                        AletaLateral  
                         translate      50*y 
                }            
                object          {
                        AletaLateral
                        scale           < 2     , .5   , 1     >
                        rotate          180*x
                        translate       -90*y-125*x
                }      
                pigment         { White_Marble } 
        } 
        sphere          {
                0,
                60 
                pigment         { wood
                        color_map       {
                                [ 0 .4 color Black color Black ]
                                [ .4 1 color White color White ]
                        }  
                        scale 60 } 
                translate       <-150   , 20    , 0     >       
        }
        scale           60/500                             
  } 
  object          {
        Pez
        rotate  180*x       
        scale   10*FBAR_L
        rotate  -90*z
        translate       3000*z*FBAR_L+700*y*FBAR_L
  }
  sphere          {
        0 ,     250*FBAR_L
        pigment         { White_Marble }    
        translate       3000*z*FBAR_L
  }  
  translate       < 0, 1000,-3000>*FBAR_L
}


#declare FBAR_CirculoPiedra  = cylinder      {
        -1000*FBAR_L*y  ,-900*FBAR_L*y  , 500*FBAR_L
        texture         { T_Stone7 
        }
        normal          {
                granite
        }
        finish          {
                phong 0
                specular 0 
        }
        translate       +1000*FBAR_L*y
}    
   
