// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 octubre 2010
//                
// Este dibujo esta en unidades arbitrarias
// Existen problemas, al escalar con la textura interior,
// deberia tomar precauciones
// ademas deberia elevar el valor de la
// variable max_trace_level
//
// El objeto FBWF_FishBowlWithFishes se coloca segun
// Minimo <-141.000, -141.000,-141.000>
// Maximo < 141.000,   65.000, 141.000>
// con el centro cercano a <0,0,0>
//
// se permiten modificadores transform
// #declare FBWF_TransformFish1 { ... }
// se aplica sobre un pez en el origen
// valor default = origen
// #declare FBWF_TransformFish2 { ... }
// se aplica sobre el otro pez
// valor default = 
//          rotate        -5*x+5*z+30*y
//          translate     70*x+30*y
//
// Para colocarlo simplemente.  El elevado valor de max_trace_level
// disminuye rayitas
// y puntos negros... 
// global_settings         {
//   max_trace_level       20
// }    
// object { FBWF_FishBowlWithFishes } 
// 
// Para su uso con transform...
// #declare FBWF_TransformFish1    = transform {
//          translate      30*z+30*x
// }
// #declare FBWF_TransformFish2    = transform {
//           rotate        -5*x+5*z+30*y
//           translate     -(70*x+30*y)
// }  
// #declare FBWF_POV3_1            = on;
// si se activa, realiza simplificaciones para compatibilidad con
// POV3.1.  Se pierde calidad de resultados.  
// En algunas versiones de POVRay se activa automticamente.
// #include "FBowlWF.inc"   
// global_settings         {
//   max_trace_level       20
// }    
// object { FBWF_FishBowlWithFishes }
// 

#include "colors.inc"
#include "glass.inc"

#ifndef ( FBWF_POV3_1 )
  #if ( version < 3.2 )
    #declare FBWF_POV3_1        = on;
  #else
    #declare FBWF_POV3_1        = off;
  #end
#end

#local   Pez    = union         {
        blob            {
                threshold      .65 
                cylinder       {
                        <-200  , 0     ,  0    >,
                        < 200  , 0     ,  0    >, 110  ,1     
                }                                     
                cylinder       {
                        <-150  , 35    ,  0    >,
                        < 150  , 35    ,  0    >,  80  ,1     
                }                             
                cylinder       {
                        <-150  , -35   ,  0    >,
                        < 150  , -35   ,  0    >,  80  ,1     
                }                              
                cylinder       {
                        <-100  , 70    ,  0    >,
                        < 100  , 70    ,  0    >,  70  ,1     
                }                             
                cylinder       {
                        <-100  ,-70    ,  0    >,
                        < 100  ,-70    ,  0    >,  70  ,1     
                }                           
                cylinder       {
                        <- 70  ,  85   ,  0    >,
                        <  70  ,  85   ,  0    >,  40  ,1     
                }                           
                cylinder       {
                        <- 70  , -85   ,  0    >,
                        <  70  , -85   ,  0    >,  40  ,1     
                }                          
                texture { 
                        pigment         {
                                gradient        y  
                                turbulence      .3
                                color_map       {
                                        [ 0 White  ]
                                        [ 1 Orange ]
                                }
                                translate       -.5
                                rotate          -30*z  
                                scale           500 
                        }
                }
                texture         {     
                        pigment         {
                                bozo
                                frequency       3
                                color_map       {
                                        [ 0 0.5 color rgbt 1 color rgbt 1 ]
                                        [ 0.5 1.0 color rgbt <1,0,0,1> 
                                                color rgbt <1,0,0,.5>]
                            
                                }
                                scale   200
                        }
                }   
                normal  {               
                        gradient        y  
                        turbulence      .3
                        normal_map      {
                                [ 0 bumps .3           ]
                                [ 1 bumps 1            ]
                        }  
                        translate       -.5
                        rotate          -30*z  
                        scale           10 
                }
        }
        #local   B11    = < 0   ,-2     , 0     >; 
        #local   B12    = < 0   ,-1     , 0     >; 
        #local   B13    = < 0   , 1     , 0     >;
        #local   B14    = < 0   , 2     , 0     >;      
        #local   B21    = < 2   ,-4     , 0     >; 
        #local   B22    = < 2   ,-1     , 1     >; 
        #local   B23    = < 2   , 1     ,-1     >;
        #local   B24    = < 2   , 4     , 0     >;    
        #local   B31    = < 5.5 ,-7     , 0     >; 
        #local   B32    = < 3.25,-6     , 0     >; 
        #local   B33    = < 4   , 5     , 0     >;
        #local   B34    = < 5   , 6     , 0     >;      
        #local   B41    = < 8   ,-9     ,-2     >; 
        #local   B42    = < 3   ,-5     , 1     >; 
        #local   B43    = < 5   , 5     , -1    >;
        #local   B44    = < 8   , 8     , 2     >;      
        bicubic_patch   {
                 type           1
                 flatness       0.001
                 u_steps        4
                 v_steps        4
                 #if ( FBWF_POV3_1 = off )
                 uv_vectors
                 < 0    , 0     >
                 < 1    , 0     >
                 < 1    , 1     >
                 < 0    , 1     >
                 #end
                 B11,   B12     , B13   , B14
                 B21,   B22     , B23   , B24
                 B31,   B32     , B33   , B34
                 B41,   B42     , B43   , B44
                 #if ( FBWF_POV3_1 = off )
                 uv_mapping
                 #end
                texture { 
                        pigment         {     
                                gradient        y   
                                color_map       {
                                        [ 0 color rgbt <0.5,0.5,0.5,0.5> ]
                                        [ 1 color rgbt 1 ]
                                }
                                scale 50 
                        }                       
                }
                texture {     
                        pigment         {
                                gradient        y  
                                turbulence      .3
                                color_map       {
                                        [ 0 color rgbt <1,1,1,.5>  ]
                                        [ 1 color rgbt <1,.5,0,.5> ]
                                }
                                translate       -.5
                                rotate          -30*z  
                                scale           500 
                        }
                }
                texture         {     
                        pigment         {
                                bozo
                                frequency       3
                                color_map       {
                                        [ 0 0.5 color rgbt 1 color rgbt 1 ]
                                        [ 0.5 1.0 color rgbt <1,0,0,1> 
                                                color rgbt <1,0,0,.5>]
                            
                                }
                                scale   200
                        }
                }  
                 scale          25
                 translate      220*x
        }     
        #local   B11    = < 0   , 0     , 0     >; 
        #local   B12    = < 1   , 0     , 0     >; 
        #local   B13    = < 3   , 0     , 0     >;
        #local   B14    = < 4   , 0     , 0     >;    
        #local   B21    = < 0.2 , 1     , 0     >; 
        #local   B22    = < 2   , 1     , 0     >; 
        #local   B23    = < 3.5 , 1     , 0     >;
        #local   B24    = < 4.8 , 1     , 0     >;    
        #local   B31    = < 1.5 , 2.5   , 0     >; 
        #local   B32    = < 3   , 2     , 0     >; 
        #local   B33    = < 4.5 , 2     , 0     >;
        #local   B34    = < 6.8 , 2     , 0     >;   
        #local   B41    = < 2.5 , 3     , 0     >; 
        #local   B42    = < 4   , 3     , 0     >; 
        #local   B43    = < 6   , 3     , 0     >;
        #local   B44    = < 7   , 5     , 0     >;     
        #local   AletaLateral   = bicubic_patch         {
                 type           1
                 flatness       0.001             
                 u_steps        4
                 v_steps        4
                 #if ( FBWF_POV3_1 = off )
                 uv_vectors
                 < 0    , 0     >
                 < 1    , 0     >
                 < 1    , 1     >
                 < 0    , 1     >
                 #end
                 B11,   B12     , B13   , B14
                 B21,   B22     , B23   , B24
                 B31,   B32     , B33   , B34
                 B41,   B42     , B43   , B44
                 #if ( FBWF_POV3_1 = off )
                 uv_mapping
                 #end
                 scale          25
                 no_shadow  
        }
        union           {           
                object          {    
                        AletaLateral  
                         translate      50*y 
                }            
                object          {
                        AletaLateral
                        scale           < 2     , .5   , 1     >
                        rotate          180*x
                        translate       -90*y-125*x
                }       
                texture { 
                        pigment         {     
                                gradient        x   
                                color_map       {
                                        [ 0 color rgbt <0.5,0.5,0.5,0.5> ]
                                        [ 1 color rgbt 1 ]
                                }
                                scale 50 
                        }                       
                }
                texture {     
                        pigment         {
                                gradient        y  
                                turbulence      .3
                                color_map       {
                                        [ 0 color rgbt <1,1,1,.5>  ]
                                        [ 1 color rgbt <1,.5,0,.5> ]
                                }
                                translate       -.5
                                rotate          -30*z  
                                scale           500 
                        }
                }
                texture         {     
                        pigment         {
                                bozo
                                frequency       3
                                color_map       {
                                        [ 0 0.5 color rgbt 1 color rgbt 1 ]
                                        [ 0.5 1.0 color rgbt <1,0,0,1> 
                                                color rgbt <1,0,0,.5>]
                            
                                }
                                scale   200
                        }
                }    
        } 
        sphere          {
                0,
                60 
                pigment         { wood
                        color_map       {
                                [ 0 .4 color Black color Black ]
                                [ .4 1 color White color White ]
                        }
                   //     rotate   
                        scale 60 } 
                translate       <-150   , 20    , 0     >       
        }
        scale           60/500                             
}     
// Water1 es una modificacion de Water en textures.inc POVRAY 3.62
#local   Water1 =
texture {
    pigment{ rgbft <0.8, 0.8, 0.9, 0.9, 0.2 > }
    normal {
        ripples 0.50
        frequency 10
    }
    finish {
        reflection
        #if ( FBWF_POV3_1 = off )
          {0.3, 1 fresnel}

        conserve_energy
        #end
    }
}
#local   Water_Int1 =
interior {
    ior 1.33
}

#local   M_Water1 =
material {
    texture {Water1}
    interior {Water_Int1}
}

#declare FBWF_FishBowlWithFishes        =
union           {               
        object  { 
          Pez 
          #ifdef ( FBWF_TransformFish1 )
            transform   {
              FBWF_TransformFish1
            }
          #end
        }
        object  { 
          Pez 
          #ifndef ( FBWF_TransformFish2 )
            rotate        -5*x+5*z+30*y
            translate     70*x+30*y
          #else
            transform { 
              FBWF_TransformFish2    
            }
          #end
        }   
        difference      {  
                sphere  {
                        0       , 135
                }   
                plane           {
                        -y      , -55
                }
                material         { M_Water1 
                }        
        }
        difference      {
                merge { sphere  {
                        0       , 141
                  }
                  cylinder      {
                        -120*y,-141*y,100
                  }
                }                    
                sphere  {
                        0       , 136
                }
                plane   {
                        -y      , -65
                }
                material         { 
                texture 
                  {
                    #if ( FBWF_POV3_1 )
                      T_Glass1
                    #else
                    pigment { color Clear }
                    #end
                    finish { F_Glass1 }

                  }
                #if ( FBWF_POV3_1 = off )
                interior { I_Glass1 fade_color color 0.8*<0.9,0.9,1.0> }
                #end
                }   
        }
        finish          { ambient .6 }     
}
