// This file is licensed under the terms of the CC-LGPL.

// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 11 octubre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El objeto HBDW_HairBrushDailyWoman se coloca segun
// Maximo: <   74,   22,   24>*L
// Minimo: <  -89,  -22,  -24>*L
// con el centro cercano a <0,0,0>
//
// tiene unicamente los modificador adicional optativos
// #declare HBDW_WoodTexture     = texture {...}
// para cambiar el tipo de madera, o soporte y 
// #declare HBDW_HairTexture     = texture {...}
// para la textura de los cabellos
//
// Para colocarlo simplemente 
// object { HBDW_HairBrushDailyWoman }
                                     
#include "colors.inc"
#include "woods.inc"
#local   HBDW_L              = 0.001;     
#local   HBDW_S              = seed( 121 );   
       
// disculpas por el "extrao" metodo de definicion
// tuve dificultades para ingresar datos en la Biblioteca de POV-Ray
#ifndef ( HBDW_HairTexture )
  #declare HBDW_HairTexture  = texture { pigment { Gray30 } }
#end
          
#ifndef (HBDW_WoodTexture ) 
  #declare HBDW_WoodTexture  = texture { T_Wood9 }
#end

#local   HBDW_Pelos1         = union {
  #local   HBDW_LargoPelo    = 1000*HBDW_L;
  #local   HBDW_Sita         = 0;
  #local   HBDW_Ro           = pi/30;
  #local   HBDW_DeltaRo      = HBDW_Ro/3;
  #local   HBDW_DeltaSita    = pi/5;
  #while ( HBDW_Ro > 0 )
    #local   HBDW_Sita       = HBDW_DeltaSita*rand( HBDW_S );
    #while ( HBDW_Sita < 2*pi )
      #local   HBDW_LargoActualPelo  = HBDW_LargoPelo
                        *( 1+0.1*rand( HBDW_S ) );
      cylinder    {
        0         ,
        < HBDW_LargoActualPelo*sin( HBDW_Ro )*cos( HBDW_Sita ), 
                HBDW_LargoActualPelo,
                  HBDW_LargoActualPelo*sin( HBDW_Ro )*sin( HBDW_Sita ) >, 
                  10*HBDW_L
        texture         { HBDW_HairTexture }    
        scale           20*HBDW_L/HBDW_LargoPelo
      }
      #local   HBDW_Sita     = HBDW_Sita+HBDW_DeltaSita;
    #end
    #local   HBDW_Ro         = HBDW_Ro-HBDW_DeltaRo;
  #end
}

#declare HBDW_HairBrushDailyWoman    = union         {
   #local   HBDW_LargoBasePelos      = 71*HBDW_L;
   #local   HBDW_FactorX             = 3;
   merge        {
     cylinder     {
        0       , < HBDW_LargoBasePelos, 0, 0 >, 8*HBDW_L
     }
     sphere     {
        0       , 8*HBDW_L
        scale   < 1/HBDW_FactorX, 1, 1 >
     }
     sphere     {
        0       , 8*HBDW_L
        scale   < 1/HBDW_FactorX, 1, 1 >
        translate       HBDW_LargoBasePelos*x
     }
     object     {
       lathe        {
         quadratic_spline
         5,
         < 4*HBDW_L,-0.5*HBDW_LargoBasePelos >,
         < 6*HBDW_L, 0.01*HBDW_L >,
         < 8*HBDW_L, 0.5*HBDW_LargoBasePelos >,
         < 8*HBDW_L, 0.98*HBDW_LargoBasePelos >,
         < 0  ,      HBDW_LargoBasePelos >
       }
       scale    < 1, 1.2, 1 >
       rotate     90*z
     } 
     texture { HBDW_WoodTexture }
   }
   #local   HBDW_DeltaLargoBase      = HBDW_LargoBasePelos/16.8;
   #local   HBDW_CuentaLargo         = 0;
   #local   HBDW_RecorreLargo        = HBDW_DeltaLargoBase;
   #while ( HBDW_CuentaLargo < 15 )
     #local   HBDW_CuentaRotar       = 0;
     #while ( HBDW_CuentaRotar < 6 )
       object       {
         HBDW_Pelos1
         translate  HBDW_RecorreLargo*x
         rotate    HBDW_CuentaRotar*60*x
       }
       object       {
         HBDW_Pelos1
         rotate     360/12*x
         translate  ( HBDW_RecorreLargo+HBDW_DeltaLargoBase*0.5 )*x
         rotate     HBDW_CuentaRotar*60*x
       }
       #local   HBDW_CuentaRotar    = HBDW_CuentaRotar+1;
     #end
     #local   HBDW_RecorreLargo      = HBDW_RecorreLargo+
                                HBDW_DeltaLargoBase;
     #local   HBDW_CuentaLargo       = HBDW_CuentaLargo+1;
   #end
}
