// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 17 enero 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// "RCMH_Rallador.inc" crea un rallador simple de cocina
// con cuatro diferentes tipos de hojas
// Sus dimensiones son:
// Alto                 = 154*L
// AnchoFrontal         = 65*L
// AnchoLateral         = 47*L
// Su ubicacion primaria es con la base centrada en el origen
// su Ancho Frontal apuntando hacia z-
//
// Para ponerlo en pantalla simplemente utilice la macro default
// #include "RCMH_Rallador.inc"
// object { RCMH_Rallador() }
// Otra alternativa disponible es utilizar la macro:
// object { RCMH_RalladorCocinaMultiHoja
//              ( TexturaMetal, TexturaPlastico, TexturaAgarradera ) }  
//      TexturaMetal    : textura de la zona de rallado
//      TexturaPlastico : textura de la base rectangular de la agarradera
//      TexturaAgarradera       : textura de la curva de la agarradera
//
// Para accesar a las siguientes texturas basicas que
// no deberian modificarse, las variables son
// #declare RCMH_TexturaMetalBase
// #declare RCMH_TexturaPlasticoBase 
// #declare RCMH_TexturaAgarraderaBase
// Si usted desea modificar la textura default, utilice 
// las siguientes variables tipo "#ifndef"
// #declare RCMH_TexturaMetalDefault
// #declare RCMH_TexturaPlasticoDefault
// #declare RCMH_TexturaAgarraderaDefault
// Por ejemplo 
// #include "RCMH_Rallador.inc"
// #declare CustomTextura               = texture       {
//   pigment            { Cyan }
// }
// #declare RCMH_TexturaPlasticoDefault = texture       {
//   average
//   texture_map   {
//      [ 0.5 RCMH_TexturaMetalBase ]
//      [ 0.5 CustomTextura         ]
//   }
// }
// object { RCMH_Rallador() }
// Donde CustomTextura seria una textura de su propia creacion
//

#include "colors.inc" 
#include "RCMH.inc"

#local   EjeMejorado            = false;
#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;     
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
}         
light_source    {
         <-1000  , 500   , -4000 >*L
         White
}
light_source    {
         < 1000  , 500   , -4000 >*L
         White
}
background      {
         Gray90
}


#local   FactorAcercamiento     = 7.5;
object          {      
        RCMH_Rallador()   
        translate       -65*L*y
        translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                                /( FactorAcercamiento )*OjoAbsoluto*L*z
} 
 
 
