// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 31 enero 2011
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// "TrasteroSMB.inc" dibuja un Trastero de sala
// Sus dimensiones son ( sin deformaciones adicionales ):
// Alto                 = 1392*L
// AnchoFrontal         = 894*L
// AnchoLateral         = 307*L
//   mas un ligero exceso hacia adelante
//   por la agarradera de 10*L
//   mas una capita delgada de madera atras de 2*L
// Su ubicacion primaria es con la base trasera centrada en el origen
// ( sin incluir la capita delgada )
// su Ancho Frontal apuntando hacia z-
// Las dimensiones de la macro default variaran un poco
// por pseudo-aleatorios desplazamientos de gaveta y puerta.
//
// Para ponerlo en pantalla simplemente utilice la macro default
// #include "TSMB.inc"
// object { TSMB_Trastero1() }
// Otra alternativa disponible es utilizar la macro:
// object { TSMB_TrasteroSalaMaderaBarnizada
//  ( TexturaBase, TexturaMetal, TexturaBarata,
//        Gaveta1, Gaveta2, Gaveta3, Puerta1, Puerta2, Puerta3, Central )
//      TexturaBase     : Textura principal del objeto
//      TexturaMetal    : Textura de las agarraderas metalicas
//      TexturaBarata   : El interior de las gavetas, la parte
//              posterior del trastero, utiliza madera de inferior calidad
//      Gaveta1         : fraccion de 0 a 1 de apertura de Gaveta
//                              Lateral Izquierda
//      Gaveta2         : fraccion de 0 a 1 de apertura de Gaveta 
//                              Central Inferior
//      Gaveta3         : fraccion de 0 a 1 de apertura de Gaveta
//                              Lateral Derecha
//      Puerta1         : Angulo grados de apertura puerta compartimento
//                              Inferior Lateral Izquierdo
//      Puerta2         : Angulo grados de apertura puerta compartimento
//                              Inferior Central
//      Puerta3         : Angulo grados de apertura puerta compartimento
//                              Inferior Lateral Derecho
//      Central         : fraccion de 0 a 1 de apertura de Gaveta
//                              Superior Central
// Un valor 1.0 de apertura representa como un 70% del recorrido
//
// Para accesar a las siguientes texturas basicas que
// no deberian modificarse, las variables son
// #declare TSMB_TexturaBaseTrastero
// #declare TSMB_TexturaMaderaBarato 
// #declare TSMB_TexturaMetalBarato
// Si usted desea modificar la textura default, utilice 
// las siguientes variables tipo "#ifndef"
// #declare TSMB_TexturaBaseTrasteroDefault
// #declare TSMB_TexturaMaderaBaratoDefault
// #declare TSMB_TexturaMetalBaratoDefault 
// Para activar compatibilidad con POVRay 3.1.
//    (innecesario pero se recomienda)
// #declare TSMB_POV3_1         = on;
// Por ejemplo 
// #include "TSMB.inc"
// #declare CustomTextura               = texture       {
//   pigment            { Cyan }
// }
// #declare TSMB_TexturaBaseTrasteroDefault = texture       {
//   average
//   texture_map   {
//      [ 0.5 TSMB_TexturaBaseTrastero ]
//      [ 0.5 CustomTextura            ]
//   }
// }
// object { TSMB_Trastero1() }
// Donde CustomTextura seria una textura de su propia creacion 
// Cada llamado de la macro genera las siguientes variables
// TSMB_AlturaGaveta[3][2]
//           [0][0] : Esquina interior Gaveta Lateral Izquierda
//                      apunta hacia <-1,-1,-1>
//           [0][1] : Esquina interior Gaveta Lateral Izquierda
//                      apunta hacia <+1,+1,+1>
//           [1][0] : Esquina interior Gaveta Central          
//                      apunta hacia <-1,-1,-1>
//           [1][1] : Esquina interior Gaveta Central           
//                      apunta hacia <+1,+1,+1>
//           [2][0] : Esquina interior Gaveta Lateral Derecha  
//                      apunta hacia <-1,-1,-1>
//           [2][1] : Esquina interior Gaveta Lateral Derecha   
//                      apunta hacia <+1,+1,+1 >
// Las direcciones se refieren al sistema original de creacion
// de la macro, tal como se explica arriba, include fraccion de apertura
// TSMB_AlturaNivel1    : altura y objetos del nivel sobre las gavetas
// TSMB_AlturaNivel2    : altura y objetos nivel gavetilla central
// TSMB_AlturaNivel3    : altura y objetos nivel tercero
// TSMB_AlturaNivel4    : altura y de la zona superior del trastero
//  

#include "colors.inc"
#include "TSMB.inc"

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;     
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    


object  {
  TSMB_Trastero1()
  translate     -700*L*y+1000*L*z
}

