// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 6 diciembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// El objeto creado por la macro es una ventana de garage.  Se ubica
// segun las siguientes coordenadas:
// Minimo <  -320,      0,  -35 >*L
// Maximo <   320,   1110,  106 >*L
// el origen se encuentra debajo del centro inferior del marco
// Si se elimina la reja metalica, las dimensiones seran
// Minimo <  -320,      0,  -35 >*L
// Maximo <   320,   1110,   35 >*L
//
// El programador dispone de las siguientes definiciones
// "declare", para sus ajustes
// #declare WHFG_AnchoMarco                = 640*L;
// #declare WHFG_AltoMarco                 = 740*L;
// #declare WHFG_ProfundidadMarco          = 70*L;
// no modificables desde el exterior
// El radio del semicirculo superior seria simplemente
// "radio del semicirculo superior" = WHFG_AnchoMarco/2
// 
// Para crear el objeto, es probable se necesite perforar una
// pared.  Esto se puede realizar por diferencia con
// WHFG_ContainerDifferenceWHFG
// que contiene el marco de profundidad doble
// por ejemplo
// union        {
//   difference {
//      "ParedCustom..."
//      WHFG_ContainerDifferenceWHFG
//   }
//   WHFG_WindowHouseFrontGarage( 0.1, true )
// }
// La macro seria
// WHFG_WindowHouseFrontGarage( FraccionVidrio, BanderaReja )
//   FraccionVidrio       = de 0.0 a 1.0, cerrado... hasta 90 grados
//   BanderaReja          = true con rejas, false las elimina
//
// acepta los siguientes modificadores (si se indica es default) 
//   #declare WHFG_POV3_1                          = off;
//                      para asegurar compatibilidad con POVRay 3.1.
//                      Innecesario en versin actual.
//                      Se recomienda su uso para
//                      versiones futuras del objeto (activa con on).
//   #declare WHFG_FactorContainerDifference       = 1.0;
//                      permite aumentar la profundidad en pared
//                      de WHFG_ContainerDifferenceWHFG para
//                      paredes de mayor grosor.
//                      El valor default produce el doble del marco  
//   #declare WHFG_TexturaContainerDifference   = texture { ... } 
//                      permite aplicar una textura por diferencia
//                      cuando se perfora la pared
//                      por default no aplica ninguna textura
//   #declare WHFG_TexturaMarcoVentana          = texture { ... }
//                      se aplica en el marco 
//   #declare WHFG_TexturaVidrioVentana         = texture { ... }
//                      se aplica en el vidrio superior                             
//   #declare WHFG_TexturaVidrioRectangular     = texture { ... } 
//                      se aplica en las laminas rectangulares de vidrio
//   #declare WHFG_TexturaSujetaVidrio          = texture { ... }       
//                      se aplica en el soporte de las laminas
//                      rectangulares, directamente
//                      a ambos lados de los vidrio
//   #declare WHFG_TexturaSujetaSujetaVidrio    = texture { ... }
//                      soporte metalico en ambas laterales de los
//                      vidrios rectangulares
//   #declare WHFG_TexturaRejaMetalica          = texture { ... }
//                      textura para la reja
// Para usarlo es suficiente
// #include "WHFG.inc"
// object       {
//   WHFG_WindowHouseFrontGarage(0.0,true)
// }
//       

#include "colors.inc"
#declare WHFG_EjeMejorado            = false;
#declare WHFG_OjoAbsoluto            = 256;
#declare WHFG_VecesCentroAbsoluto    = 10;     
#declare WHFG_L                      = 0.001;

camera {
        location  <   0,  0, 
                -( WHFG_VecesCentroAbsoluto+1 )*WHFG_OjoAbsoluto >*WHFG_L
        direction z
        sky       y
        angle     38.74
}         
light_source    {
         < 500  , 500   , -4000 >*WHFG_L
         White
}
light_source    {
         <-500  , 500   , -4000 >*WHFG_L
         White
}
background      {
         Cyan*0.8
}    
#include "WHFG.inc"

object  {
  WHFG_WindowHouseFrontGarage( 0.3, true )
  rotate        30*y
  translate     200*WHFG_L*z-550*WHFG_L*y
}

